
void() T_MissileTouch;
void() info_player_start;
void(entity targ, entity attacker, float location) ClientObituary;
void() NextLevel; //###

void() monster_death_use;

//============================================================================

/*
============
CanDamage

Returns true if the inflictor can directly damage the target.  Used for
explosions and melee attacks.
============
*/
float(entity targ, entity inflictor) CanDamage =
{
// bmodels need special checking because their origin is 0,0,0
	if (targ.movetype == MOVETYPE_PUSH)
	{
		traceline(inflictor.origin, 0.5 * (targ.absmin + targ.absmax), TRUE, self);
		if (trace_fraction == 1)
			return TRUE;
		if (trace_ent == targ)
			return TRUE;
		return FALSE;
	}
	
	traceline(inflictor.origin, targ.origin, TRUE, self);
	if (trace_fraction == 1)
		return TRUE;
	traceline(inflictor.origin, targ.origin + '15 15 0', TRUE, self);
	if (trace_fraction == 1)
		return TRUE;
	traceline(inflictor.origin, targ.origin + '-15 -15 0', TRUE, self);
	if (trace_fraction == 1)
		return TRUE;
	traceline(inflictor.origin, targ.origin + '-15 15 0', TRUE, self);
	if (trace_fraction == 1)
		return TRUE;
	traceline(inflictor.origin, targ.origin + '15 -15 0', TRUE, self);
	if (trace_fraction == 1)
		return TRUE;

	return FALSE;
};


/*
============
Killed
============
*/
void(entity targ, entity attacker, float location) Killed =
{
	local entity oself;
	local float fraglimit; // ###

	oself = self;
	self = targ;
	
	if (self.health < -99)
		self.health = -99;		// don't let sbar look bad if a player

	if (self.movetype == MOVETYPE_PUSH || self.movetype == MOVETYPE_NONE)
	{	// doors, triggers, etc
		self.th_die ();
		self = oself;
		return;
	}

	self.enemy = attacker;

// bump the monster counter
	if (self.flags & FL_MONSTER)
	{
		killed_monsters = killed_monsters + 1;
		WriteByte (MSG_ALL, SVC_KILLEDMONSTER);
	}

	ClientObituary(self, attacker, location);
/*
	if (targ.classname == "player")
	{
//		centerprint(self, "You killed ",attacker.netname);  // Print the player's netname (name) and health
//    	sprint(attacker,targ.netname);
//    	sprint(attacker,"Mined ");
//    	sprint(attacker,targ.netname);
//    	sprint(attacker,"!\n");
	}
*/
//###
	fraglimit = cvar("fraglimit");
	if (fraglimit && attacker.frags >= fraglimit)
		NextLevel ();
//###
	self.takedamage = DAMAGE_NO;
	self.touch = SUB_Null;

	monster_death_use();
	self.th_die ();
	
	self = oself;
};

float(entity targ, entity inflictor) LocateDmg =
{
	if (targ.health > 0)
	{
		local float MaxZ;
		local float Height;
		local float z_rel;
		local float z_ratio;
		local float LOC;

		MaxZ = targ.maxs_z;
		Height = fabs(targ.mins_z);
		z_rel = inflictor.origin_z - targ.origin_z + fabs(targ.mins_z);
		z_ratio = z_rel / Height;

		if (z_ratio > 1.75)
			LOC =  LOC_HEAD;
		else if (z_ratio > 1.5)
			LOC = LOC_TORSO;
		else if (z_ratio > 1.3)
			LOC = LOC_STOMACH;
		else if (z_ratio > 1.1)
			LOC = LOC_GROIN;
		else if (z_ratio > 0.4)
			LOC = LOC_LEGS;
		else
			LOC = LOC_FEET;

		if(targ.angles_y + 90 > inflictor.angles_y && targ.angles_y - 90 < inflictor.angles_y)
			LOC = LOC + 1;

		return LOC;
	}
};



/*
============
T_Damage

The damage is coming from inflictor, but get mad at attacker
This should be the only function that ever reduces health.
============
*/
void(entity targ, entity inflictor, entity attacker, float damage) T_Damage=
{
	local	vector	dir;
	local	entity	oldself;
	local	float	save;
	local	float	take;

	local float location;

	if (!targ.takedamage)
		return;

// used by buttons and triggers to set activator for target firing
	damage_attacker = attacker;

// locational damage start
	location = LocateDmg(targ, inflictor);

    if ((attacker.weapon == IT_ROCKET_LAUNCHER) ||
		(attacker.weapon == IT_GRENADE_LAUNCHER) ||
		(attacker.weapon == IT_TEKBOW))
    {
		if (location == LOC_HEAD)
		{
//    		sprint(attacker,"Hit head!\n");
			damage = damage * 2;
		}
		else if (location == LOC_HEAD_BACK)
		{
//    		sprint(attacker,"Hit back of head!\n");
			damage = damage * 4;
		}
		else if (location == LOC_TORSO)
		{
			damage = damage;
//    		sprint(attacker,"Hit torso!\n");
		}      
		else if (location == LOC_STOMACH)
		{
//    		sprint(attacker,"Hit stomach!\n");
			damage = damage * 0.8;
		}
		else if (location == LOC_TORSO_BACK || location == LOC_STOMACH_BACK)
		{
//    		sprint(attacker,"Hit back of torso/stomach!\n");
			damage = damage * 1.5;
		}
		else if (location == LOC_GROIN)
		{
//    		sprint(attacker,"Hit groin!\n");
			damage = damage * 0.6;
		}
		else if (location == LOC_GROIN_BACK)
		{
//    		sprint(attacker,"Hit back of groin!\n");
			damage = damage * 0.55;
		}
		else if (location == LOC_LEGS)
		{
//    		sprint(attacker,"Hit legs!\n");
			damage = damage * 0.6;
		}
		else if (location == LOC_LEGS_BACK)
		{
//    		sprint(attacker,"Hit back of legs!\n");
			damage = damage * 0.65;
		}
		else // LOC_FEET or LOC_FEET_BACK
		{
//    		sprint(attacker,"Hit feet!\n");
			damage = damage * 0.5;
		}
    }
	else
    {
//    		sprint(attacker,"Hit with something!\n");
			damage = damage;
    }

// end locational damage

// check for quad damage powerup on the attacker
	if (attacker.super_damage_finished > time)
		damage = damage * 4;

// save damage based on the target's armor level

	if (targ.deathtype != "drowning")
	{
		save = ceil(targ.armortype*damage);
		if (save >= targ.armorvalue)
		{
			save = targ.armorvalue;
			targ.armortype = 0;	// lost all armor
			targ.items2 = targ.items2 - (targ.items2 & (IT2_ARMOR1 | IT2_ARMOR2 | IT2_ARMOR3));
		}
	}
	else
		save = 0;
	
	targ.armorvalue = targ.armorvalue - save;
	take = ceil(damage-save);

// add to the damage total for clients, which will be sent as a single
// message at the end of the frame
// FIXME: remove after combining shotgun blasts?
	if (targ.flags & FL_CLIENT)
	{
		targ.dmg_take = targ.dmg_take + take;
		targ.dmg_save = targ.dmg_save + save;
		targ.dmg_inflictor = inflictor;
	}

// figure momentum add
	if ( (inflictor != world) && (targ.movetype == MOVETYPE_WALK) )
	{
		dir = targ.origin - (inflictor.absmin + inflictor.absmax) * 0.5;
		dir = normalize(dir);
		targ.velocity = targ.velocity + dir*damage*8;
	}

// check for godmode or invincibility
	if (targ.flags & FL_GODMODE)
		return;
	if (targ.invincible_finished >= time)
	{
		if (self.invincible_sound < time)
		{
			sound (targ, CHAN_ITEM, "items/protect3.wav", 1, ATTN_NORM);
			self.invincible_sound = time + 2;
		}
		return;
	}

// team play damage avoidance
//	if ( (teamplay == 1) && (targ.team > 0)&&(targ.team == attacker.team) )
	if ( (teamplay == 1) && (targ.team > 0) && (targ.team == attacker.team)
	&& (targ != attacker) 			
	&& (attacker.classname == "player")
	&& (inflictor.classname != "door") )	// because squishing a teammate is still possible
		return;
		
// do the damage
	targ.health = targ.health - take;
			
	if (targ.health <= 0)
	{
		Killed (targ, attacker, location);
		return;
	}

// react to the damage
	oldself = self;
	self = targ;

	if ( (self.flags & FL_MONSTER) && attacker != world)
	{
	// get mad unless of the same class (except for soldiers)
		if (self != attacker && attacker != self.enemy)
		{
			if ( (self.classname != attacker.classname) 
			|| (self.classname == "monster_army" ) )
			{
				if (self.enemy.classname == "player")
					self.oldenemy = self.enemy;
				self.enemy = attacker;
				FoundTarget ();
			}
		}
	}

	if (self.th_pain)
	{
		self.th_pain (attacker, take);
	// nightmare mode monsters don't go into pain frames often
		if (skill == 3)
			self.pain_finished = time + 5;		
	}

	self = oldself;
};

/*
============
T_RadiusDamage
============
*/
void(entity inflictor, entity attacker, float damage, entity ignore) T_RadiusDamage =
{
	local	float 	points;
	local	entity	head;
	local	vector	org;

	head = findradius(inflictor.origin, damage+40);
	
	while (head)
	{
		if (head != ignore)
		{
			if (head.takedamage)
			{
				org = head.origin + (head.mins + head.maxs)*0.5;
				points = 0.5*vlen (inflictor.origin - org);
				if (points < 0)
					points = 0;
				points = damage - points;
				if (head == attacker)
					points = points * 0.5;
				if (points > 0)
				{
					if (CanDamage (head, inflictor))
					{	// shambler takes half damage from all explosions
						if (head.classname == "monster_shambler")						
							T_Damage (head, inflictor, attacker, points*0.5);
						else
							T_Damage (head, inflictor, attacker, points);
					}
				}
			}
		}
		head = head.chain;
	}
};

/*
============
T_BeamDamage
============
*/
void(entity attacker, float damage) T_BeamDamage =
{
	local	float 	points;
	local	entity	head;
	
	head = findradius(attacker.origin, damage+40);
	
	while (head)
	{
		if (head.takedamage)
		{
			points = 0.5*vlen (attacker.origin - head.origin);
			if (points < 0)
				points = 0;
			points = damage - points;
			if (head == attacker)
				points = points * 0.5;
			if (points > 0)
			{
				if (CanDamage (head, attacker))
				{
					if (head.classname == "monster_shambler")						
						T_Damage (head, attacker, attacker, points*0.5);
					else
						T_Damage (head, attacker, attacker, points);
				}
			}
		}
		head = head.chain;
	}
};

