/*
==============================================================================

SOLDIER / PLAYER

==============================================================================
*/

$cd id1/models/soldier3
$origin 0 -6 24
$base base		
$skin skin

$frame Idle1

$frame Ready1

$frame Walk1 Walk2 Walk3 Walk4 Walk5 Walk6

$frame Run1 Run2 Run3 Run4 Run5 Run6 Run7 Run8

$frame Jump1 Jump2 Jump3

$frame Swim1 Swim2 Swim3 Swim4 Swim5 Swim6 Swim7 Swim8

$frame AttackA1 AttackA2 AttackA3 AttackA4 AttackA5 AttackA6 AttackA7
$frame AttackB1 AttackB2 AttackB3 AttackB4 AttackB5 AttackB6 AttackB7
$frame AttackC1 AttackC2 AttackC3 AttackC4 AttackC5 AttackC6 AttackC7
$frame AttackD1 AttackD2 AttackD3 AttackD4 AttackD5 AttackD6 AttackD7

$frame Death1 Death2 Death3 Death4 Death5 Death6 Death7 Death8
$frame Death9 Death10 Death11 Death12

/*
==============================================================================
SOLDIER CODE
==============================================================================
*/

void() armyBulletEffect;
void() army_fire;
void() SoldierThrowGrenade;

void()	army_stand1	=[	$Idle1,	army_stand1	] {ai_stand();

if (random() < 0.001)
	sound (self, CHAN_VOICE, "soldier/idle.wav", 1, ATTN_IDLE);
};

void() army_walk1 =[ $Walk1, army_walk2 ] {ai_walk(5);};
void() army_walk2 =[ $Walk2, army_walk3 ] {ai_walk(5);};
void() army_walk3 =[ $Walk3, army_walk4 ] {ai_walk(5);};
void() army_walk4 =[ $Walk4, army_walk5 ] {ai_walk(5);};
void() army_walk5 =[ $Walk5, army_walk6 ] {ai_walk(5);};
void() army_walk6 =[ $Walk6, army_walk1 ] {ai_walk(5);};

void() army_run1 =[	$Run1, army_run2 ] {ai_run(15);};
void() army_run2 =[	$Run2, army_run3 ] {ai_run(15);};
void() army_run3 =[	$Run3, army_run4 ] {ai_run(15);};
void() army_run4 =[	$Run4, army_run5 ] {ai_run(15);};
void() army_run5 =[	$Run5, army_run6 ] {ai_run(15);};
void() army_run6 =[	$Run6, army_run7 ] {ai_run(15);};
void() army_run7 =[	$Run7, army_run8 ] {ai_run(15);};
void() army_run8 =[	$Run8, army_run1 ] {ai_run(15);};

void()	army_atka1	=[	$AttackA1,	army_atka2	] {ai_face();};
void()	army_atka2	=[	$AttackA2,	army_atka3	] {ai_face();};
void()	army_atka3	=[	$AttackA3,	army_atka4	] {ai_face();army_fire();
self.effects = self.effects | EF_MUZZLEFLASH;};
void()	army_atka4	=[	$AttackA4,	army_atka5	] {ai_face();};
void()	army_atka5	=[	$AttackA5,	army_atka6	] {ai_face();};
void()	army_atka6	=[	$AttackA6,	army_atka7	] {ai_face();SUB_CheckRefire (army_atka1);}
void()	army_atka7	=[	$AttackA7,	army_run1	] {ai_face();};

void()	army_atkb1	=[	$AttackB1,	army_atkb2	] {ai_face();};
void()	army_atkb2	=[	$AttackB2,	army_atkb3	] {ai_face();};
void()	army_atkb3	=[	$AttackB3,	army_atkb4	] {ai_face();army_fire();
self.effects = self.effects | EF_MUZZLEFLASH;};
void()	army_atkb4	=[	$AttackB4,	army_atkb5	] {ai_face();};
void()	army_atkb5	=[	$AttackB5,	army_atkb6	] {ai_face();};
void()	army_atkb6	=[	$AttackB6,	army_atkb7	] {ai_face();SUB_CheckRefire (army_atkb1);}
void()	army_atkb7	=[	$AttackB7,	army_run1	] {ai_face();};

void()	army_atkc1	=[	$AttackC1,	army_atkc2	] {ai_face();setsize (self, '-8 -8 -24', '16 16 20');};
void()	army_atkc2	=[	$AttackC2,	army_atkc3	] {ai_face();};
void()	army_atkc3	=[	$AttackC3,	army_atkc4	] {ai_face();army_fire();
self.effects = self.effects | EF_MUZZLEFLASH;};
void()	army_atkc4	=[	$AttackC4,	army_atkc5	] {ai_face();};
void()	army_atkc5	=[	$AttackC5,	army_atkc6	] {ai_face();};
void()	army_atkc6	=[	$AttackC6,	army_atkc7	] {ai_face();SUB_CheckRefire (army_atkc1);}
void()	army_atkc7	=[	$AttackC7,	army_run1	] {ai_face();setsize (self, '-8 -8 -24', '16 16 32');};

void()	army_atkd1	=[	$AttackD1,	army_atkd2	] {ai_face();};
void()	army_atkd2	=[	$AttackD2,	army_atkd3	] {ai_face();};
void()	army_atkd3	=[	$AttackD3,	army_atkd4	] {ai_face();};
void()	army_atkd4	=[	$AttackD4,	army_atkd5	] {ai_face();};
void()	army_atkd5	=[	$AttackD5,	army_atkd6	] {ai_face();}
void()	army_atkd6	=[	$AttackD6,	army_atkd7	] {ai_face();SoldierThrowGrenade();};
void()	army_atkd7	=[	$AttackD7,	army_run1	] {ai_face();};

void()	army_atk =
{
	local float r;

	local vector dir;
	local entity en;

	en = self.enemy;

	dir = en.origin - self.origin;
	dir = normalize (dir);

	self.v_angle = vectoangles (dir);

	r = random();

	if(skill >= 1)
	{
		if (vlen (self.enemy.origin - self.origin) > 400)
			army_atkd1 ();
		else
		{
			if (r < 0.3)
				army_atka1 ();
			else if (r < 0.5)
				army_atkb1 ();
			else
				army_atkc1 ();
		}
	}
	else
	{
		if (r < 0.3)
			army_atka1 ();
		else if (r < 0.5)
			army_atkb1 ();
		else
			army_atkc1 ();
	}
};

/*
void()	army_pain1	=[	$pain1,		army_pain2	] {};
void()	army_pain2	=[	$pain2,		army_pain3	] {};
void()	army_pain3	=[	$pain3,		army_pain4	] {};
void()	army_pain4	=[	$pain4,		army_pain5	] {};
void()	army_pain5	=[	$pain5,		army_pain6	] {};
void()	army_pain6	=[	$pain6,		army_run1	] {ai_pain(1);};

void()	army_painb1	=[	$painb1,	army_painb2	] {};
void()	army_painb2	=[	$painb2,	army_painb3	] {ai_painforward(13);};
void()	army_painb3	=[	$painb3,	army_painb4	] {ai_painforward(9);};
void()	army_painb4	=[	$painb4,	army_painb5	] {};
void()	army_painb5	=[	$painb5,	army_painb6	] {};
void()	army_painb6	=[	$painb6,	army_painb7	] {};
void()	army_painb7	=[	$painb7,	army_painb8	] {};
void()	army_painb8	=[	$painb8,	army_painb9	] {};
void()	army_painb9	=[	$painb9,	army_painb10] {};
void()	army_painb10=[	$painb10,	army_painb11] {};
void()	army_painb11=[	$painb11,	army_painb12] {};
void()	army_painb12=[	$painb12,	army_painb13] {ai_pain(2);};
void()	army_painb13=[	$painb13,	army_painb14] {};
void()	army_painb14=[	$painb14,	army_run1	] {};

void()	army_painc1	=[	$painc1,	army_painc2	] {};
void()	army_painc2	=[	$painc2,	army_painc3	] {ai_pain(1);};
void()	army_painc3	=[	$painc3,	army_painc4	] {};
void()	army_painc4	=[	$painc4,	army_painc5	] {};
void()	army_painc5	=[	$painc5,	army_painc6	] {ai_painforward(1);};
void()	army_painc6	=[	$painc6,	army_painc7	] {ai_painforward(1);};
void()	army_painc7	=[	$painc7,	army_painc8	] {};
void()	army_painc8	=[	$painc8,	army_painc9	] {ai_pain(1);};
void()	army_painc9	=[	$painc9,	army_painc10] {ai_painforward(4);};
void()	army_painc10=[	$painc10,	army_painc11] {ai_painforward(3);};
void()	army_painc11=[	$painc11,	army_painc12] {ai_painforward(6);};
void()	army_painc12=[	$painc12,	army_painc13] {ai_painforward(8);};
void()	army_painc13=[	$painc13,	army_run1] {};
*/
void(entity attacker, float damage)	army_pain =
{
	local float rs;
	
	if (self.pain_finished > time)
		return;

// don't make multiple pain sounds right after each other

// ax pain sound
	if (self.axhitme == 1)
	{
		self.axhitme = 0;
		sound (self, CHAN_VOICE, "player/axhit1.wav", 1, ATTN_NORM);
		return;
	}

	rs = rint((random() * 10) + 1);

	if (rs == 1)
		self.noise = "player/pain1.wav";
	else if (rs == 2)
		self.noise = "player/pain2.wav";
	else if (rs == 3)
		self.noise = "player/pain3.wav";
	else if (rs == 4)
		self.noise = "player/pain4.wav";
	else if (rs == 5)
		self.noise = "player/pain5.wav";
	else if (rs == 6)
		self.noise = "player/pain6.wav";
	else if (rs == 7)
		self.noise = "player/pain7.wav";
	else if (rs == 8)
		self.noise = "player/pain8.wav";
	else if (rs == 9)
		self.noise = "player/pain9.wav";
	else if (rs == 10)
		self.noise = "player/pain10.wav";
	else
		self.noise = "player/pain11.wav";

	sound (self, CHAN_VOICE, self.noise, 1, ATTN_NORM);
	return;
};

void() army_bullet_touch;

void() army_bullet_touch =
{
    local float		rs;
    local float     d;

	if (other == self.owner)
		return;

	if (other.classname == "monster_army")
	{
		remove(self);
		return;
	}

	if (other.solid == SOLID_TRIGGER)
		return;	// trigger field, do nothing

	if (pointcontents(self.origin) == CONTENT_SKY)
	{
		remove(self);
		return;
	}

	// hit something that bleeds
	if (other.takedamage)
	{
	    if(other.solid == SOLID_BSP)
	    {
//		    spawn_touchblood (25, trace_ent);
		    remove(self);
        }
	    else
	        BloodSplat();

        if(skill == 3)
            d = 25;
        else if(skill == 2)
	        d = 25;
        else if(skill == 1)
	        d = 10;
        else
	        d = 5;

		T_Damage (other, self, self.owner, d);
	}
	else
	{
	    WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
		WriteByte (MSG_BROADCAST, TE_GUNSHOT);
	    WriteCoord (MSG_BROADCAST, self.origin_x);
	    WriteCoord (MSG_BROADCAST, self.origin_y);
	    WriteCoord (MSG_BROADCAST, self.origin_z);
	    Spark();

    	rs = rint ((random() * 8) + 1);
    	if (rs == 1)
    		self.noise = "weapons/ric1.wav";
    	if (rs == 2)
    		self.noise = "weapons/ric2.wav";
    	if (rs == 3)
    		self.noise = "weapons/ric3.wav";
    	if (rs == 4)
    		self.noise = "weapons/ric4.wav";
    	if (rs == 5)
    		self.noise = "weapons/ric5.wav";
    	if (rs == 6)
    		self.noise = "weapons/ric6.wav";
    	if (rs == 7)
    		self.noise = "weapons/ric7.wav";
    	if (rs == 8)
    		self.noise = "weapons/ric8.wav";
    	if (rs == 9)
    		self.noise = "weapons/ric9.wav";

    	sound (self, CHAN_AUTO, self.noise, 1, ATTN_NORM);
    }
};

void() armyBulletEffect =
{
	local	entity bullet;

	bullet = spawn ();
	bullet.owner = self;
	bullet.movetype = MOVETYPE_FLYMISSILE;
	bullet.solid = SOLID_BBOX;
	bullet.classname = "bullet";

// set bullet speed	

	makevectors (self.angles);

	bullet.velocity = normalize(self.enemy.origin - self.origin);
	if (skill > 2)
	    bullet.velocity = ((bullet.velocity * 2500 + ((v_right * 200) * crandom ())) + ((v_up * 100) * crandom ()));
	else if (skill == 2)
	    bullet.velocity = ((bullet.velocity * 2500 + ((v_right * 400) * crandom ())) + ((v_up * 200) * crandom ()));
	else
	    bullet.velocity = ((bullet.velocity * 2500 + ((v_right * 600) * crandom ())) + ((v_up * 300) * crandom ()));
	bullet.angles = vectoangles(bullet.velocity);

// set bullet fly function

	bullet.nextthink = time + 0.08;
	bullet.think = bullet_reposition;

	setmodel (bullet, "progs/bullet.mdl");
	bullet.touch = army_bullet_touch;

	setsize (bullet, '0 0 0', '0 0 0');		
	setorigin (bullet,(self.origin + ('0 0 22')));
};

void() army_fire =
{
	local	vector	dir;
	local	entity	en;
	
	ai_face();
	
	sound (self, CHAN_WEAPON, "weapons/defire.wav", 1, ATTN_NORM);

	en = self.enemy;
	
	dir = en.origin - self.origin;
	dir = normalize (dir);

	self.v_angle = vectoangles (dir);

	if (self.v_angle_x > 180)
		self.v_angle_x = self.v_angle_x - 360; // corrects an ID mistake

	self.v_angle_x = self.v_angle_x * -1;     // corrects an ID mistake

	if (self.v_angle_x > 80)
		self.v_angle_x = 80;

	if (self.v_angle_x < -80)
		self.v_angle_x = -80;

    armyBulletEffect();
    eject_case ((((self.origin + (v_forward * 20))) + ('0 0 20')) + (v_right * 10),dir);
};

void() SoldierGrenadeExplode =
{
	T_RadiusDamage (self, self.owner, 50, world);

	sound (self, CHAN_VOICE, "weapons/r_exp3.wav", 1, ATTN_NORM);

	WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
	WriteByte (MSG_BROADCAST, TE_EXPLOSION);
	WriteCoord (MSG_BROADCAST, self.origin_x);
	WriteCoord (MSG_BROADCAST, self.origin_y);
	WriteCoord (MSG_BROADCAST, self.origin_z);
	WriteCoord (MSG_BROADCAST, 1.0); // Red explosion colour
	WriteCoord (MSG_BROADCAST, 0.5); // Green explosion colour
	WriteCoord (MSG_BROADCAST, 0.0); // Blue explosion colour

	BecomeExplosion ();
};

void() SoldierGrenadeTouch =
{
	if (other == self.owner)
		return;		// don't explode on owner

	if (other.classname == "monster_army")
		return;

	if (other.takedamage == DAMAGE_AIM)
	{
		self.velocity = '0 0 -5';
		self.solid = SOLID_NOT;
//		SoldierGrenadeExplode();
//		return;
	}

	sound (self, CHAN_VOICE, "weapons/bounce.wav", 1, ATTN_NORM);	// bounce sound
	if (self.velocity == '0 0 0')
		self.avelocity = '0 0 0';
};

/*
================
SoldierThrowGrenade
================
*/
void() SoldierThrowGrenade =
{
	local	entity missile;
	local vector distancedelta;
	local vector nozdistancedelta;
	local vector move;
	local float	fly;

	self.effects = self.effects | EF_MUZZLEFLASH;

//	sound (self, CHAN_WEAPON, "weapons/grenade.wav", 1, ATTN_NORM);

	missile = spawn ();
	missile.owner = self;
	missile.movetype = MOVETYPE_BOUNCE;
	missile.solid = SOLID_BBOX;

// set missile speed

	makevectors (self.angles);

// new up-down aware code
	distancedelta = self.enemy.origin - self.origin; //work out distance vector
	nozdistancedelta = distancedelta;  //copy to no height distance vector

	nozdistancedelta_z = 0;  //remove height

	missile.velocity = normalize(distancedelta); //set the velocity to the distance
	missile.velocity = missile.velocity * 600;   //give it more power

	missile.velocity_z = missile.velocity_z + vlen(nozdistancedelta)*0.70; //add extra height for extra distance
// end new up-down aware code

// new leading code
// get the entities xy velocity
	if (skill >= 1) //lead on hard and up.
	{
		move = self.enemy.velocity;
		move_z = 0;

		fly = vlen(self.enemy.origin - self.origin) / 400;

		missile.velocity = missile.velocity + (fly * move);
	}
// end leading code

	missile.avelocity = '300 300 300';

	missile.angles = vectoangles(missile.velocity);

	missile.touch = SoldierGrenadeTouch;

// set missile duration
	missile.nextthink = time + 2;
	missile.think = SoldierGrenadeExplode;

	setmodel (missile, "progs/gren_g.mdl");
	setsize (missile, '0 0 0', '0 0 0');
	setorigin (missile, self.origin);
};

void()	army_die1	=[	$Death1,	army_die2	] {};
void()	army_die2	=[	$Death2,	army_die3	] {};
void()	army_die3	=[	$Death3,	army_die4	]
{
	self.solid = SOLID_NOT;

	if (random() < 0.5)
		self.ammo_nails = 4;
	else
		self.ammo_nails = 8;

	if (random() < 0.25)
		self.ammo_rockets = 1;
	else
		self.ammo_rockets = 0;

//	if (random() < 0.5)
		self.weapon = IT_SHOTGUN;

	WeaponDrop();
};
void()	army_die4	=[	$Death4,	army_die5	] {};
void()	army_die5	=[	$Death5,	army_die6	] {};
void()	army_die6	=[	$Death6,	army_die7	] {};
void()	army_die7	=[	$Death7,	army_die8	] {};
void()	army_die8	=[	$Death8,	army_die9	] {};
void()	army_die9	=[	$Death9,	army_die10	] {};
void()	army_die10	=[	$Death10,	army_die11	] {};
void()	army_die11	=[	$Death11,	army_die12	] {};
void()	army_die12	=[	$Death12,	army_die12	] {};

/*
void()	army_cdie1	=[	$deathc1,	army_cdie2	] {};
void()	army_cdie2	=[	$deathc2,	army_cdie3	] {ai_back(5);};
void()	army_cdie3	=[	$deathc3,	army_cdie4	]
{self.solid = SOLID_NOT;self.ammo_nails = 7;self.weapon = IT_SHOTGUN;WeaponDrop();ai_back(4);};
void()	army_cdie4	=[	$deathc4,	army_cdie5	] {ai_back(13);};
void()	army_cdie5	=[	$deathc5,	army_cdie6	] {ai_back(3);};
void()	army_cdie6	=[	$deathc6,	army_cdie7	] {ai_back(4);};
void()	army_cdie7	=[	$deathc7,	army_cdie8	] {};
void()	army_cdie8	=[	$deathc8,	army_cdie9	] {};
void()	army_cdie9	=[	$deathc9,	army_cdie10	] {};
void()	army_cdie10	=[	$deathc10,	army_cdie11	] {};
void()	army_cdie11	=[	$deathc11,	army_cdie11	] {};
*/

void() army_die =
{
    local float		rs;

// check for gib
	if (self.health < -50)
	{
		if (damage_attacker.weapon == IT_ROCKET_LAUNCHER ||
			damage_attacker.weapon == IT_GRENADE_LAUNCHER ||
			damage_attacker.weapon == IT_LIGHTNING)
		{
			self.skin = 0;
			sound (self, CHAN_VOICE, "player/gib.wav", 1, ATTN_NORM);

//		ThrowHead ("progs/h_guard.mdl", self.health);
			ThrowHead ("progs/gib1.mdl", self.health);
			ThrowGib ("progs/gib1.mdl", self.health);
			ThrowGib ("progs/gib2.mdl", self.health);
			ThrowGib ("progs/gib3.mdl", self.health);
			ThrowGib ("progs/gib1.mdl", self.health);
			ThrowGib ("progs/gib2.mdl", self.health);
			ThrowGib ("progs/gib3.mdl", self.health);
			return;
		}
	}

// regular death
// don't make multiple pain sounds right after each other

// ax pain sound
	if (self.axhitme == 1)
	{
		self.axhitme = 0;
		sound (self, CHAN_VOICE, "player/axhit1.wav", 1, ATTN_NORM);
		army_die1 ();
		return;
	}

	rs = rint((random() * 10) + 1);

	if (rs == 1)
		self.noise = "player/pain1.wav";
	else if (rs == 2)
		self.noise = "player/pain2.wav";
	else if (rs == 3)
		self.noise = "player/pain3.wav";
	else if (rs == 4)
		self.noise = "player/pain4.wav";
	else if (rs == 5)
		self.noise = "player/pain5.wav";
	else if (rs == 6)
		self.noise = "player/pain6.wav";
	else if (rs == 7)
		self.noise = "player/pain7.wav";
	else if (rs == 8)
		self.noise = "player/pain8.wav";
	else if (rs == 9)
		self.noise = "player/pain9.wav";
	else if (rs == 10)
		self.noise = "player/pain10.wav";
	else
		self.noise = "player/pain11.wav";

	sound (self, CHAN_VOICE, self.noise, 1, ATTN_NORM);

//	if (random() < 0.5)
		army_die1 ();
//	else
//		army_cdie1 ();
};


/*QUAKED monster_army (1 0 0) (-16 -16 -24) (16 16 40) Ambush
*/
void() monster_army =
{	
	if (deathmatch & DM_DM_MASK)
	{
		remove(self);
		return;
	}

//	precache_model ("progs/soldier.mdl");
//	precache_model ("progs/h_guard.mdl");
	precache_model ("progs/gib1.mdl");
	precache_model ("progs/gib2.mdl");
	precache_model ("progs/gib3.mdl");
	precache_model ("progs/gren_g.mdl");

	precache_sound ("soldier/death1.wav");
	precache_sound ("soldier/idle.wav");
	precache_sound ("soldier/pain1.wav");
	precache_sound ("soldier/pain2.wav");
	precache_sound ("soldier/sattck1.wav");
//	precache_sound ("soldier/sight1.wav");

	precache_sound ("player/udeath.wav");		// gib death

	self.solid = SOLID_SLIDEBOX;
	self.movetype = MOVETYPE_STEP;

	setmodel (self, "progs/p_pistol.mdl");
	setsize (self, '-8 -8 -24', '8 8 32');

	if (cvar("skill") == 3)
	{
		self.skin = 1;
	    self.health = 200;
	}
    else if (cvar("skill") == 2)
	{
		self.skin = 2;
	    self.health = 100;
	}
    else if (cvar("skill") == 1)
	{
		self.skin = 3;
	    self.health = 50;
	}
    else
	{
		self.skin = 0;
	    self.health = 25;
	}

	self.th_stand = army_stand1;
	self.th_walk = army_walk1;
	self.th_run = army_run1;
	self.th_missile = army_atk;
	self.th_pain = army_pain;
	self.th_die = army_die;

	walkmonster_start ();
};

void() monster_ogre =
{
	monster_army ();
}
void() monster_ogre_marksman =
{
	monster_army ();
};
void() monster_shambler =
{
	monster_army ();
}
void() monster_knight =
{
	monster_army ();
}
void() monster_wizard =
{
	monster_army ();
}
void() monster_dog =
{
	monster_army ();
}
void() monster_zombie =
{
	monster_army ();
}
void() monster_boss =
{
	monster_army ();
}
void() monster_tarbaby =
{
	monster_army ();
}
void() monster_hell_knight =
{
	monster_army ();
}
void() monster_fish =
{
	monster_army ();
}
void() monster_shalrath =
{
	monster_army ();
}
void() monster_enforcer =
{
	monster_army ();
}
void() monster_oldone =
{
	monster_army ();
}
