/*
*/
void (entity targ, entity inflictor, entity attacker, float damage) T_Damage;
void () player_run;
void(entity bomb, entity attacker, float rad, entity ignore) T_RadiusDamage;
void(vector org, vector vel, float damage, entity targ) SpawnBlood;
void() SuperDamageSound;

// called by worldspawn
void() W_Precache =
{
	precache_sound ("weapons/r_exp3.wav");	// new rocket explosion
	precache_sound ("weapons/rocket1i.wav");	// spike gun
	precache_sound ("weapons/sgun1.wav");
	precache_sound ("weapons/guncock.wav");	// player shotgun
	precache_sound ("weapons/ric1.wav");	// ricochet (used in c code)
	precache_sound ("weapons/ric2.wav");	// ricochet (used in c code)
	precache_sound ("weapons/ric3.wav");	// ricochet (used in c code)
	precache_sound ("weapons/spike2.wav");	// super spikes
	precache_sound ("weapons/tink1.wav");	// spikes tink (used in c code)
	precache_sound ("weapons/grenade.wav");	// grenade launcher
	precache_sound ("weapons/bounce.wav");	// grenade bounce
	precache_sound ("weapons/shotgn2.wav");	// super shotgun

	// Kurok Precache Stuff

	precache_model ("progs/v_axe.mdl");        // Knife
	precache_model ("progs/v_shot.mdl");       // Pistol
	precache_model ("progs/v_uzi.mdl");        // Uzi
	precache_model ("progs/v_sniper.mdl");      // Sniper Rifle
	precache_model ("progs/v_nail.mdl");       // Assualt Rifle
	precache_model ("progs/v_rock.mdl");       // Grenade Launcher
	precache_model ("progs/v_shot2.mdl");      // Shotgun
	precache_model ("progs/v_nail2.mdl");      // Mini Gun
	precache_model ("progs/v_rock2.mdl");      // Rocket Launcher
	precache_model ("progs/v_tekbow.mdl");     // Tekbow Weapon w/ tek arrows
	precache_model ("progs/v_bow.mdl");        // TekBow Weapon w/ normal arrows
	precache_model ("progs/v_axea.mdl");       // Knife Animations

	precache_model ("progs/scope.mdl");       // Sniper scope model

	precache_sound ("weapons/ric4.wav");	// ricochet
	precache_sound ("weapons/ric5.wav");	// ricochet
	precache_sound ("weapons/ric6.wav");	// ricochet
	precache_sound ("weapons/ric7.wav");	// ricochet
	precache_sound ("weapons/ric8.wav");	// ricochet
	precache_sound ("weapons/ric9.wav");	// ricochet
	precache_sound ("weapons/dryf.wav");    // Dry Weapon Fire
	precache_sound ("weapons/case.wav");    // Bullet/Shell case sound
	precache_sound ("weapons/bow.wav");	    // Bow Pull
	precache_sound ("weapons/bowf.wav");	// Bow Release
	precache_sound ("weapons/defire.wav");	// Pistol Fire
	precache_sound ("weapons/p_clipin.wav");	// Pistol clip in
	precache_sound ("weapons/p_clipout.wav");	// Pistol clip out
	precache_sound ("weapons/p_slide_b.wav");	// Pistol slide back
	precache_sound ("weapons/p_slide_f.wav");	// Pistol clip forward
	precache_sound ("weapons/arfire.wav");	// Assualt Rifle
	precache_sound ("weapons/uzi.wav");	// Uzi
	precache_sound ("weapons/sniperf.wav");	// Assualt Rifle
	precache_sound ("weapons/minigun.wav");	// Mini Gun	Machine
	precache_sound ("weapons/mgfire.wav");	// Mini Gun Fire
    precache_sound ("weapons/detonate.wav");    // Laser Trip Bomb
};

void(entity me, entity camera)     SetViewPoint;
void(entity me, vector viewangles) SetViewAngle;

float SVC_SETVIEWPORT = 5;    // Net.Protocol 0x05
float SVC_SETVIEWANGLES = 10; // Net.Protocol 0x0A
float SVC_UPDATEENTITY = 128; // Net.Protocol 0x80

void(entity me, entity camera) SetViewPoint =
{
  msg_entity = me;                         // target of message
  WriteByte (MSG_ONE, SVC_SETVIEWPORT);    // 5 = SVC_SETVIEWPORT;
  WriteEntity (MSG_ONE, camera);           // view port
  WriteByte (MSG_ONE, SVC_SETVIEWANGLES);  // 10 = SVC_SETVIEWANGLES
  WriteAngle(MSG_ONE, camera.angles_x);    // tilt
  WriteAngle(MSG_ONE, camera.angles_y);    // yaw
  WriteAngle(MSG_ONE, camera.angles_z);    // flip
};

void(entity me, vector viewangles) SetViewAngle =
{
  msg_entity = me;                         // target of message
  WriteByte(MSG_ONE, SVC_SETVIEWANGLES);   // 10 = SVC_SETVIEWANGLES
  WriteAngle(MSG_ONE, viewangles_x);       // tilt
  WriteAngle(MSG_ONE, viewangles_y);       // yaw
  WriteAngle(MSG_ONE, viewangles_z);       // flip
};

float() crandom =
{
	return 2*(random() - 0.5);
};

/*
================
W_FireAxe
================
*/
void() W_FireAxe =
{
	local	vector	source;
	local	vector	org;
	local   float   damage;

	damage = 40;

	makevectors (self.v_angle);
	source = self.origin + '0 0 16';
	traceline (source, source + v_forward*64, FALSE, self);
	if (trace_fraction == 1.0)
		return;

	self.punchangle_x = -5;

	org = trace_endpos - v_forward*4;

	if (trace_ent.takedamage)
	{
      	if ((trace_ent.absmax_z - trace_endpos_z) <= 8 )
		{
//			if (deathmatch)
//				centerprint(self, "HEADSHOT!!!");
        	damage = damage * 3;
		}

		trace_ent.axhitme = 1;
		SpawnBlood (org, '0 0 0', 200, trace_ent);
		T_Damage (trace_ent, self, self, damage);
	}
	else
	{	// hit wall
		sound (self, CHAN_WEAPON, "player/axhit2.wav", 1, ATTN_NORM);
		WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
		WriteByte (MSG_BROADCAST, TE_GUNSHOT);
		WriteCoord (MSG_BROADCAST, org_x);
		WriteCoord (MSG_BROADCAST, org_y);
		WriteCoord (MSG_BROADCAST, org_z);
	}
};


//============================================================================


vector() wall_velocity =
{
	local vector	vel;
	
	vel = normalize (self.velocity);
	vel = normalize(vel + v_up*(random()- 0.5) + v_right*(random()- 0.5));
	vel = vel + 2*trace_plane_normal;
	vel = vel * 200;
	
	return vel;
};


/*
================
SpawnMeatSpray
================
*/
void(vector org, vector vel) SpawnMeatSpray =
{
	local	entity missile, mpuff;
//	local	vector	org;

	missile = spawn ();
	missile.owner = self;
	missile.movetype = MOVETYPE_BOUNCE;
	missile.solid = SOLID_NOT;

	makevectors (self.angles);

	missile.velocity = vel;
	missile.velocity_z = missile.velocity_z + 250 + 50*random();

	missile.avelocity = '3000 1000 2000';
	
// set missile duration
	missile.nextthink = time + 1;
	missile.think = SUB_Remove;

	setmodel (missile, "progs/zom_gib.mdl");
	setsize (missile, '0 0 0', '0 0 0');		
	setorigin (missile, org);
};

/*
================
SpawnBlood
================
*/
void(vector org, vector vel, float damage, entity targ) SpawnBlood =
{
    // target entity is a BSP model
	if(targ.solid == SOLID_BSP)
		particle (org, vel*0.1, 6, damage);
//	else
//	{
//		if (!targ.classname == "world")
//	    	particle (org, vel*0.1, 73, damage*2);
//	}
};

/*
================
spawn_touchblood
================
*/
void(float damage, entity targ) spawn_touchblood =
{
	local vector	vel;

	vel = wall_velocity () * 0.2;
	SpawnBlood (self.origin + vel*0.01, vel, damage, targ);
};


/*
================
SpawnChunk
================
*/
void(vector org, vector vel) SpawnChunk =
{
	particle (org, vel*0.02, 0, 10);
};

/*
==============================================================================

MULTI-DAMAGE

Collects multiple small damages into a single damage

==============================================================================
*/

entity	multi_ent;
float	multi_damage;

void() ClearMultiDamage =
{
	multi_ent = world;
	multi_damage = 0;
};

void() ApplyMultiDamage =
{
	if (!multi_ent)
		return;
	T_Damage (multi_ent, self, self, multi_damage);
};

void(entity hit, float damage) AddMultiDamage =
{
	if (!hit)
		return;
	
	if (hit != multi_ent)
	{
		ApplyMultiDamage ();
		multi_damage = damage;
		multi_ent = hit;
	}
	else
		multi_damage = multi_damage + damage;
};

/*
==============================================================================

BULLETS

==============================================================================
*/

void()	blood1	=	[0,		blood2] {self.nextthink = time + 0.05;};
void()	blood2	=	[1,		blood3] {self.nextthink = time + 0.05;};
void()	blood3	=	[2,		SUB_Remove] {self.nextthink = time + 0.05;};

void() BloodSplat =
{
	if (random() < 0.25)
		sound (self, CHAN_AUTO, "weapons/bhit3.wav", 1, ATTN_NORM);
	else if (random() < 0.5)
		sound (self, CHAN_AUTO, "weapons/bhit2.wav", 1, ATTN_NORM);
	else
		sound (self, CHAN_AUTO, "weapons/bhit.wav", 1, ATTN_NORM);

	self.movetype = MOVETYPE_NONE;
	self.velocity = '0 0 0';
	self.touch = SUB_Null;
	setmodel (self, "gfx/blood.spr");
	self.solid = SOLID_NOT;
	blood1 ();
};

void(vector org) BloodSplatTrace =
{
	local entity blood;

	blood = spawn();

	blood.owner = self;
	blood.classname = "spike";
	blood.movetype = MOVETYPE_NONE;
	blood.velocity = '0 0 0';
	blood.origin = org;
	blood.touch = SUB_Null;
	setmodel (blood, "gfx/blood.spr");
	blood.solid = SOLID_NOT;
	blood.think = blood1;
	blood.nextthink = time + 0.05;

	if (random() < 0.25)
		sound (self, CHAN_AUTO, "weapons/bhit3.wav", 1, ATTN_NORM);
	else if (random() < 0.5)
		sound (self, CHAN_AUTO, "weapons/bhit2.wav", 1, ATTN_NORM);
	else
		sound (self, CHAN_AUTO, "weapons/bhit.wav", 1, ATTN_NORM);
};

void()	spark1	=	[0,		spark2] {self.nextthink = time + 0.03;};
void()	spark2	=	[1,		spark3] {self.nextthink = time + 0.03;};
void()	spark3	=	[2,		spark4] {self.nextthink = time + 0.03;};
void()	spark4	=	[3,		SUB_Remove] {self.nextthink = time + 0.03;};

void() Spark =
{
	self.movetype = MOVETYPE_NONE;
	self.velocity = '0 0 0';
	self.touch = SUB_Null;
	setmodel (self, "gfx/spark.spr");
	self.solid = SOLID_NOT;
	spark1 ();
};

void(vector org) SparkTrace =
{
	local entity spark;
    local float		rs;

	spark = spawn();

	spark.owner = self;
	spark.classname = "spike";
	spark.movetype = MOVETYPE_NONE;
	spark.velocity = '0 0 0';
	spark.origin = org;
	spark.touch = SUB_Null;
	setmodel (spark, "gfx/spark.spr");
	spark.solid = SOLID_NOT;
	spark.think = spark1;
	spark.nextthink = time + 0.03;

    rs = rint ((random() * 8) + 1);
    if (rs == 1)
   		spark.noise = "weapons/ric1.wav";
    if (rs == 2)
    	spark.noise = "weapons/ric2.wav";
    if (rs == 3)
    	spark.noise = "weapons/ric3.wav";
   	if (rs == 4)
    	spark.noise = "weapons/ric4.wav";
    if (rs == 5)
    	spark.noise = "weapons/ric5.wav";
    if (rs == 6)
   		spark.noise = "weapons/ric6.wav";
    if (rs == 7)
    	spark.noise = "weapons/ric7.wav";
    if (rs == 8)
    	spark.noise = "weapons/ric8.wav";
    if (rs == 9)
    	spark.noise = "weapons/ric9.wav";

    sound (spark, CHAN_AUTO, spark.noise, 1, ATTN_NORM);
};

void(vector org) SparkRapidTrace =
{
	local entity spark;
    local float		rs;

	spark = spawn();

	spark.owner = self;
	spark.classname = "spike";
	spark.movetype = MOVETYPE_NONE;
	spark.velocity = '0 0 0';
	spark.origin = org;
	spark.touch = SUB_Null;
	setmodel (spark, "gfx/spark.spr");
	spark.solid = SOLID_NOT;
	spark.think = spark1;
	spark.nextthink = time + 0.03;

    rs = rint ((random() * 8) + 1);
    if (rs == 1)
   		spark.noise = "weapons/ric1.wav";
    if (rs == 2)
    	spark.noise = "weapons/ric2.wav";
    if (rs == 3)
    	spark.noise = "weapons/ric3.wav";
   	if (rs == 4)
    	spark.noise = "weapons/ric4.wav";
    if (rs == 5)
    	spark.noise = "weapons/ric5.wav";
    if (rs == 6)
   		spark.noise = "weapons/ric6.wav";
    if (rs == 7)
    	spark.noise = "weapons/ric7.wav";
    if (rs == 8)
    	spark.noise = "weapons/ric8.wav";
    if (rs == 9)
    	spark.noise = "weapons/ric9.wav";

    sound (spark, CHAN_AUTO, spark.noise, 1, ATTN_NORM);
};

/*
================
TraceAttack
================
*/
void(float damage, vector dir) TraceAttack =
{
	local	vector	vel, org;
	
	vel = normalize(dir + v_up*crandom() + v_right*crandom());
	vel = vel + 2*trace_plane_normal;
	vel = vel * 200;

	org = trace_endpos - dir*4;

	if (pointcontents(org) == CONTENT_SKY)
		return;

	if (trace_ent.takedamage)
	{
		if(!trace_ent.classname == "func_glass")
			if(!trace_ent.classname == "func_door")
			    if(!trace_ent.classname == "func_button")
                    if(!trace_ent.classname == "explo_box")
						BloodSplatTrace(org);
//					else
//						SpawnBlood (org, vel*0.2, damage, trace_ent);

		AddMultiDamage (trace_ent, damage);
	}
	else
	{
		WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
		WriteByte (MSG_BROADCAST, TE_GUNSHOT);
		WriteCoord (MSG_BROADCAST, org_x);
		WriteCoord (MSG_BROADCAST, org_y);
		WriteCoord (MSG_BROADCAST, org_z);
	}
};

/*
================
TraceBulletAttack
================
*/
void(float damage, vector dir) TraceBulletAttack =
{
	local	vector	vel, org;

	vel = normalize(dir + v_up*crandom() + v_right*crandom());
	vel = vel + 2*trace_plane_normal;
	vel = vel * 200;

	org = trace_endpos - dir*4;

	if (pointcontents(org) == CONTENT_SKY)
		return;

	if (trace_ent.takedamage)
	{
		if(!trace_ent.classname == "func_glass")
			if(!trace_ent.classname == "func_door")
				if(!trace_ent.classname == "func_button")
                    if(!trace_ent.classname == "explo_box")
						BloodSplatTrace(org);
//					else
//						SpawnBlood (org, vel*0.2, damage, trace_ent);

		// Head
      	if ((trace_ent.absmax_z - trace_endpos_z) <= 8 )
		{
			if (deathmatch & DM_DM_MASK)
				if(trace_ent.classname == "player")
					if(trace_ent.health <= 25)
						centerprint(self, "HEADSHOT!!!");
        	damage = damage * 2;
		}
		// Torso
      	else if (((trace_ent.absmax_z - trace_endpos_z) > 8) && ((trace_ent.absmax_z - trace_endpos_z) < 35))
		{
//			if (deathmatch & DM_DM_MASK)
//				if(trace_ent.health <= 25)
//					centerprint(self, "BODYSHOT!!!");
			damage = damage; // Stop compiler warnings.
		}
		// Legs
		else
		{
//			if (deathmatch & DM_DM_MASK)
//				if(trace_ent.health <= 25)
//					centerprint(self, "LEGSHOT!!!");
			damage = damage * 0.5;
		}

		AddMultiDamage (trace_ent, damage);
	}
	else
	{
		WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
		WriteByte (MSG_BROADCAST, TE_GUNSHOT);
		WriteCoord (MSG_BROADCAST, org_x);
		WriteCoord (MSG_BROADCAST, org_y);
		WriteCoord (MSG_BROADCAST, org_z);

		SparkTrace(org);
	}
};

/*
================
TraceSniperBulletAttack
================
*/
void(float damage, vector dir) TraceSniperBulletAttack =
{
	local	vector	vel, org;

	vel = normalize(dir + v_up*crandom() + v_right*crandom());
	vel = vel + 2*trace_plane_normal;
	vel = vel * 200;

	org = trace_endpos - dir*4;

	if (pointcontents(org) == CONTENT_SKY)
		return;

	if (trace_ent.takedamage)
	{
		if(!trace_ent.classname == "func_glass")
			if(!trace_ent.classname == "func_door")
				if(!trace_ent.classname == "func_button")
                    if(!trace_ent.classname == "explo_box")
						BloodSplatTrace(org);
//					else
//						SpawnBlood (org, vel*0.2, damage, trace_ent);

		// Head
      	if ((trace_ent.absmax_z - trace_endpos_z) <= 8 )
		{
			if (deathmatch & DM_DM_MASK)
				if(trace_ent.classname == "player")
					if(trace_ent.health <= 100)
						centerprint(self, "HEADSHOT!!!");
        	damage = damage * 2;
		}
		// Torso
      	else if (((trace_ent.absmax_z - trace_endpos_z) > 8) && ((trace_ent.absmax_z - trace_endpos_z) < 35))
		{
//			if (deathmatch & DM_DM_MASK)
//				if(trace_ent.health <= 25)
//					centerprint(self, "BODYSHOT!!!");
			damage = damage; // Stop compiler warnings.
		}
		// Legs
		else
		{
//			if (deathmatch & DM_DM_MASK)
//				if(trace_ent.health <= 25)
//					centerprint(self, "LEGSHOT!!!");
			damage = damage * 0.5;
		}

		AddMultiDamage (trace_ent, damage);
	}
	else
	{
		WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
		WriteByte (MSG_BROADCAST, TE_GUNSHOT);
		WriteCoord (MSG_BROADCAST, org_x);
		WriteCoord (MSG_BROADCAST, org_y);
		WriteCoord (MSG_BROADCAST, org_z);

		SparkTrace(org);
	}
};

/*
================
TraceRapidBulletAttack
================
*/
void(float damage, vector dir) TraceRapidBulletAttack =
{
	local	vector	vel, org;

	vel = normalize(dir + v_up*crandom() + v_right*crandom());
	vel = vel + 2*trace_plane_normal;
	vel = vel * 200;

	org = trace_endpos - dir*4;

	if (pointcontents(org) == CONTENT_SKY)
		return;

	if (trace_ent.takedamage)
	{
		if(!trace_ent.classname == "func_glass")
			if(!trace_ent.classname == "func_door")
				if(!trace_ent.classname == "func_button")
                    if(!trace_ent.classname == "explo_box")
						BloodSplatTrace(org);
//					else
//						SpawnBlood (org, vel*0.2, damage, trace_ent);

		// Head
      	if ((trace_ent.absmax_z - trace_endpos_z) <= 8 )
		{
			if (deathmatch & DM_DM_MASK)
				if(trace_ent.classname == "player")
					if(trace_ent.health <= 10)
						centerprint(self, "HEADSHOT!!!");
        	damage = damage * 2;
		}
		// Torso
      	else if (((trace_ent.absmax_z - trace_endpos_z) > 8) && ((trace_ent.absmax_z - trace_endpos_z) < 35))
		{
//			if (deathmatch & DM_DM_MASK)
//				if(trace_ent.health <= 10)
//					centerprint(self, "BODYSHOT!!!");
			damage = damage; // Stop compiler warnings.
		}
		// Legs
		else
		{
//			if (deathmatch & DM_DM_MASK)
//				if(trace_ent.health <= 10)
//					centerprint(self, "LEGSHOT!!!");
			damage = damage * 0.5;
		}

		AddMultiDamage (trace_ent, damage);
	}
	else
	{
		WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
		WriteByte (MSG_BROADCAST, TE_GUNSHOT);
		WriteCoord (MSG_BROADCAST, org_x);
		WriteCoord (MSG_BROADCAST, org_y);
		WriteCoord (MSG_BROADCAST, org_z);

		SparkRapidTrace(org);
	}
};

/*
================
TracePelletAttack
================
*/
void(float damage, vector dir) TracePelletAttack =
{
	local	vector	vel, org;

	vel = normalize(dir + v_up*crandom() + v_right*crandom());
	vel = vel + 2*trace_plane_normal;
	vel = vel * 200;

	org = trace_endpos - dir*4;

	if (pointcontents(org) == CONTENT_SKY)
		return;

	if (trace_ent.takedamage)
	{
		if(!trace_ent.classname == "func_glass")
			if(!trace_ent.classname == "func_door")
				if(!trace_ent.classname == "func_button")
                    if(!trace_ent.classname == "explo_box")
						BloodSplatTrace(org);
//					else
//						SpawnBlood (org, vel*0.2, damage, trace_ent);

		// Head
      	if ((trace_ent.absmax_z - trace_endpos_z) <= 8 )
		{
			if (deathmatch & DM_DM_MASK)
				if(trace_ent.classname == "player")
					if(trace_ent.health <= 16)
						centerprint(self, "HEADSHOT!!!");
        	damage = damage * 2;
		}
		// Torso
      	else if (((trace_ent.absmax_z - trace_endpos_z) > 8) && ((trace_ent.absmax_z - trace_endpos_z) < 35))
		{
//			if (deathmatch & DM_DM_MASK)
//				if(trace_ent.health <= 16)
//					centerprint(self, "BODYSHOT!!!");
			damage = damage; // Stop compiler warnings.
		}
		// Legs
		else
		{
//			if (deathmatch & DM_DM_MASK)
//				if(trace_ent.health <= 16)
//					centerprint(self, "LEGSHOT!!!");
			damage = damage * 0.5;
		}

		AddMultiDamage (trace_ent, damage);
	}
	else
	{
		WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
		WriteByte (MSG_BROADCAST, TE_GUNSHOT);
		WriteCoord (MSG_BROADCAST, org_x);
		WriteCoord (MSG_BROADCAST, org_y);
		WriteCoord (MSG_BROADCAST, org_z);

		SparkRapidTrace(org);
	}
};

/*
================
FireBullets

Used by shotgun, super shotgun, and enemy soldier firing
Go to the trouble of combining multiple pellets into a single damage call.
================
*/
void(float shotcount, vector dir, vector spread) FireBullets =
{
	local	vector direction;
	local	vector	src;
	
	makevectors(self.v_angle);

	src = self.origin + v_forward*10;
	src_z = self.absmin_z + self.size_z * 0.90;

	ClearMultiDamage ();
	while (shotcount > 0)
	{
		direction = dir + crandom()*spread_x*v_right + crandom()*spread_y*v_up;

		traceline (src, src + direction*2048, FALSE, self);
		if (trace_fraction != 1.0)
			TraceBulletAttack (25, direction);

		shotcount = shotcount - 1;
	}
	ApplyMultiDamage ();
};

/*
================
FireSniperBullets

Used by sniper rifle
Go to the trouble of combining multiple pellets into a single damage call.
================
*/
void(float shotcount, vector dir, vector spread) FireSniperBullets =
{
	local	vector direction;
	local	vector	src;

	makevectors(self.v_angle);

	src = self.origin + v_forward*10;
	src_z = self.absmin_z + self.size_z * 0.90;

	ClearMultiDamage ();
	while (shotcount > 0)
	{
		direction = dir + crandom()*spread_x*v_right + crandom()*spread_y*v_up;

		traceline (src, src + direction*4096, FALSE, self);
		if (trace_fraction != 1.0)
			TraceSniperBulletAttack (100, direction);

		shotcount = shotcount - 1;
	}
	ApplyMultiDamage ();
};

/*
================
FireRapidBullets

Used by assualt rifle, uzi and minigun
Go to the trouble of combining multiple pellets into a single damage call.
================
*/
void(float shotcount, vector dir, vector spread) FireRapidBullets =
{
	local	vector direction;
	local	vector	src;

	makevectors(self.v_angle);

	src = self.origin + v_forward*10;
	src_z = self.absmin_z + self.size_z * 0.90;

	ClearMultiDamage ();
	while (shotcount > 0)
	{
		direction = dir + crandom()*spread_x*v_right + crandom()*spread_y*v_up;

		traceline (src, src + direction*2048, FALSE, self);
		if (trace_fraction != 1.0)
			TraceRapidBulletAttack (10, direction);

		shotcount = shotcount - 1;
	}
	ApplyMultiDamage ();
};

/*
================
FirePellets

Used by shotgun
Go to the trouble of combining multiple pellets into a single damage call.
================
*/
void(float shotcount, vector dir, vector spread) FirePellets =
{
	local	vector direction;
	local	vector	src;

	makevectors(self.v_angle);

	src = self.origin + v_forward*10;
	src_z = self.absmin_z + self.size_z * 0.90;

	ClearMultiDamage ();
	while (shotcount > 0)
	{
		direction = dir + crandom()*spread_x*v_right + crandom()*spread_y*v_up;

		traceline (src, src + direction*2048, FALSE, self);
		if (trace_fraction != 1.0)
			TracePelletAttack (16, direction);

		shotcount = shotcount - 1;
	}
	ApplyMultiDamage ();
};
/*
void() bullet_touch =
{
    local float		rs;

	if (other == self.owner)
		return;

	if (other.solid == SOLID_TRIGGER)
		return;	// trigger field, do nothing

	if (pointcontents(self.origin) == CONTENT_SKY)
	{
		remove(self);
		return;
	}

// hit something that bleeds
	if (other.takedamage)
	{
	    if(other.solid == SOLID_BSP)
	    {
		    spawn_touchblood (28, trace_ent);
		    remove(self);
        }
	    else
	        BloodSplat();
		T_Damage (other, self, self.owner, 10);
	}
	else
	{
	    WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
		WriteByte (MSG_BROADCAST, TE_GUNSHOT);
	    WriteCoord (MSG_BROADCAST, self.origin_x);
	    WriteCoord (MSG_BROADCAST, self.origin_y);
	    WriteCoord (MSG_BROADCAST, self.origin_z);
	    Spark();

    	rs = rint ((random() * 8) + 1);
    	if (rs == 1)
    		self.noise = "weapons/ric1.wav";
    	if (rs == 2)
    		self.noise = "weapons/ric2.wav";
    	if (rs == 3)
    		self.noise = "weapons/ric3.wav";
    	if (rs == 4)
    		self.noise = "weapons/ric4.wav";
    	if (rs == 5)
    		self.noise = "weapons/ric5.wav";
    	if (rs == 6)
    		self.noise = "weapons/ric6.wav";
    	if (rs == 7)
    		self.noise = "weapons/ric7.wav";
    	if (rs == 8)
    		self.noise = "weapons/ric8.wav";
    	if (rs == 9)
    		self.noise = "weapons/ric9.wav";

    	sound (self, CHAN_AUTO, self.noise, 1, ATTN_NORM);
    }
};
*/
void() bullet_reposition =
{
    self.frame = 0;
    self.frame = self.frame + 1;
    if (self.frame == 2)
        self.frame = 2;
};

void(vector offset) BulletEffect =
{
	local	entity missile;

	missile = spawn ();
	missile.owner = self;
	missile.movetype = MOVETYPE_FLYMISSILE;
	missile.solid = SOLID_BBOX;
	missile.classname = "spike";
	missile.frame = 2;

// set bullet speed

	makevectors (self.v_angle);

	missile.velocity = aim(self, 1000);
	missile.velocity = missile.velocity * 5000;
	missile.angles = vectoangles(missile.velocity);

// set bullet fly function

	missile.nextthink = time + 0.08;
	missile.think = SUB_Remove;//bullet_reposition;

	setmodel (missile, "progs/bullet.mdl");

	setsize (missile, '0 0 0', '0 0 0');
	setorigin (missile,((self.origin + ('0 0 18'))) + offset);

	missile.touch = SUB_Remove;//bullet_touch;
};

/*
================
W_FirePistol
================
*/
void() W_FirePistol =
{
	local vector dir;

	sound (self, CHAN_WEAPON, "weapons/defire.wav", 1, ATTN_NORM);	

	self.punchangle_x = -1;

	if ((deathmatch & DM_INFINITE_AMMO) && (deathmatch & DM_NO_RELOAD))
	{
		// Do nothing
	}

	else if (deathmatch & DM_INFINITE_AMMO)
		self.currentammo = self.bulletclip = self.bulletclip - 1;

	else if (deathmatch & DM_NO_RELOAD)
    	self.currentammo = self.ammo_nails1 = self.ammo_nails1 - 1;

	else
    	self.currentammo = self.bulletclip = self.bulletclip - 1;

	UpdateAmmoCounts(self);

	dir = aim (self, 100000);
	BulletEffect(v_right * 7);
	FireBullets (1, dir, '0 0 0');

	if (!deathmatch & DM_DM_MASK || coop)
		eject_case ((((self.origin + (v_forward * 15))) + ('0 0 15')) + (v_right * 6),dir);

};

/*
================
W_FireShotgun
================
*/
void() W_FireShotgun =
{
	local vector dir;

	sound (self, CHAN_WEAPON, "weapons/guncock.wav", 1, ATTN_NORM);	

	self.punchangle_x = -2;
	
	if (!deathmatch & DM_INFINITE_AMMO)
		self.currentammo = self.ammo_shells1 = self.ammo_shells1 - 1;

	UpdateAmmoCounts(self);

	dir = aim (self, 100000);
/*
	PelletEffect();
	PelletEffect();
	PelletEffect();
	PelletEffect();
	PelletEffect();
*/
	FirePellets (5, dir, '0.08 0.08 0');

	if (!deathmatch & DM_DM_MASK || coop)
		eject_case ((((self.origin + (v_forward * 20))) + ('0 0 15')) + (v_right * 10),dir);
};

/*
================
W_FireSuperShotgun
================
*/
void() W_FireSuperShotgun =
{
	local vector dir;

	if (self.currentammo == 1)
	{
		W_FireShotgun ();
		return;
	}
		
	sound (self ,CHAN_WEAPON, "weapons/shotgn2.wav", 1, ATTN_NORM);	

	self.punchangle_x = -2;

	if (!deathmatch & DM_INFINITE_AMMO)
		self.currentammo = self.ammo_shells1 = self.ammo_shells1 - 2;

	UpdateAmmoCounts(self);

	dir = aim (self, 100000);
	FireBullets (14, dir, '0.14 0.08 0');

	if (!deathmatch & DM_DM_MASK || coop)
		eject_case ((((self.origin + (v_forward * 20))) + ('0 0 20')) + (v_right * 10),dir);
};

/*
================
W_FireAssualtRifle
================
*/
void() W_FireAssualtRifle =
{
	local vector dir;

	sound (self, CHAN_WEAPON, "weapons/arfire.wav", 1, ATTN_NORM);	

	self.punchangle_x = -1;

	if ((deathmatch & DM_INFINITE_AMMO) && (deathmatch & DM_NO_RELOAD))
	{
		// Do nothing
	}

	else if (deathmatch & DM_INFINITE_AMMO)
		self.currentammo = self.rifleclip = self.rifleclip - 1;

	else if (deathmatch & DM_NO_RELOAD)
    	self.currentammo = self.ammo_nails1 = self.ammo_nails1 - 1;

	else
    	self.currentammo = self.rifleclip = self.rifleclip - 1;

	UpdateAmmoCounts(self);

	dir = aim (self, 100000);
//    RapidBulletEffect();
	FireRapidBullets (1, dir, '0.02 0.02 0');

	if (!deathmatch & DM_DM_MASK || coop)
		eject_case ((((self.origin + (v_forward * 15))) + ('0 0 20')) + (v_right * 8),dir);
};

/*
================
W_FireUzi
================
*/
void() W_FireUzi =
{
	local vector dir;

	sound (self, CHAN_WEAPON, "weapons/uzi.wav", 1, ATTN_NORM);

	self.punchangle_x = -1;

	if ((deathmatch & DM_INFINITE_AMMO) && (deathmatch & DM_NO_RELOAD))
	{
		// Do nothing
	}

	else if (deathmatch & DM_INFINITE_AMMO)
		self.currentammo = self.uziclip = self.uziclip - 1;

	else if (deathmatch & DM_NO_RELOAD)
    	self.currentammo = self.ammo_nails1 = self.ammo_nails1 - 1;

	else
    	self.currentammo = self.uziclip = self.uziclip - 1;

	UpdateAmmoCounts(self);

	dir = aim (self, 100000);
	FireRapidBullets (1, dir, '0.04 0.04 0');
//	UziBulletEffect();

	if (!deathmatch & DM_DM_MASK || coop)
		eject_case ((((self.origin + (v_forward * 15))) + ('0 0 17')) + (v_right * 6),dir);
};

/*
================
W_FireSniper
================
*/
void() W_FireSniper =
{
	local vector dir;

	sound (self, CHAN_WEAPON, "weapons/sniperf.wav", 1, ATTN_NORM);

	if (self.zoomtoggle == 0)
	{
		self.punchangle_x = -5;
		BulletEffect(v_right * 7);
	}
	else
		BulletEffect(v_right * 1);

	if (!deathmatch & DM_INFINITE_AMMO)
	    self.currentammo = self.ammo_50cal = self.ammo_50cal - 1;

	UpdateAmmoCounts (self);

	dir = aim (self, 1000000);
	FireSniperBullets (1, dir, '0 0 0');

	if (!deathmatch & DM_DM_MASK || coop)
		eject_case ((((self.origin + (v_forward * 15))) + ('0 0 15')) + (v_right * 6),dir);
};

/*
================
W_FireMiniGun
================
*/
void() W_FireMiniGun =
{
	local vector dir;

	sound (self, CHAN_WEAPON, "weapons/mgfire.wav", 1, ATTN_NORM);	

	self.punchangle_x = -2;
	
	if (!deathmatch & DM_INFINITE_AMMO)
		self.currentammo = self.ammo_nails1 = self.ammo_nails1 - 1;

	UpdateAmmoCounts(self);

	dir = aim (self, 100000);
	FireRapidBullets (1, dir, '0.06 0.06 0');
//    UziBulletEffect();

	if (!deathmatch & DM_DM_MASK || coop)
		eject_case ((((self.origin + (v_forward * 15))) + ('0 0 20')) + (v_right * 8),dir);
};

/*
==============================================================================

ROCKETS

==============================================================================
*/

void()	s_smoke1	=	[0,		s_smoke2] {setmodel (self, "progs/s_smoke.spr");self.nextthink = time + 3 + random()*0.5;self.velocity = '0 0 8';};
void()	s_smoke2	=	[1,		s_smoke3] {self.nextthink = time + 3 + random()*0.5;};
void()	s_smoke3	=	[2,		s_smoke4] {self.nextthink = time + 3 + random()*0.5;};
void()	s_smoke4	=	[3,		s_smoke5] {self.nextthink = time + 3 + random()*0.5;};
void()	s_smoke5	=	[4,		s_smoke6] {self.nextthink = time + 3 + random()*0.5;};
void()	s_smoke6	=	[5,		SUB_Remove] {self.nextthink = time + 3 + random()*0.5;};

void()	s_explode1	=	[0,		s_explode2] {};
void()	s_explode2	=	[1,		s_explode3] {};
void()	s_explode3	=	[2,		s_explode4] {};
void()	s_explode4	=	[3,		s_explode5] {};
void()	s_explode5	=	[2,		s_explode6] {};
void()	s_explode6	=	[1,		SUB_Remove] {s_smoke1 ();};

void() BecomeExplosion =
{
	self.movetype = MOVETYPE_NOCLIP;
	self.origin = self.origin + crandom()*v_forward*10 + v_up * 10 + crandom()*v_right*10;
	self.velocity = '0 0 1';
	self.velocity = self.velocity + crandom()*v_forward*10 + v_up * 50 + crandom()*v_right*10;
	self.touch = SUB_Null;
	setmodel (self, "progs/s_explod.spr");
	self.solid = SOLID_NOT;
	s_explode1 ();
};

void() GrenadeExplode;
void() MineExplode;

void() RocketExplode =
{
	local entity    ptr;

	// don't do radius damage to the other, because all the damage
	// was done in the impact
	T_RadiusDamage (self, self.owner, 120, other);

//	sound (self, CHAN_WEAPON, "weapons/r_exp3.wav", 1, ATTN_NORM);
	self.origin = self.origin - 8*normalize(self.velocity);

	WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
	WriteByte (MSG_BROADCAST, TE_EXPLOSION);
	WriteCoord (MSG_BROADCAST, self.origin_x);
	WriteCoord (MSG_BROADCAST, self.origin_y);
	WriteCoord (MSG_BROADCAST, self.origin_z);
	WriteCoord (MSG_BROADCAST, 1.0); // Red explosion colour
	WriteCoord (MSG_BROADCAST, 0.5); // Green explosion colour
	WriteCoord (MSG_BROADCAST, 0.0); // Blue explosion colour

//  call "findradius" to return list of entity's found
//  (I have chosen to use a radius of 150 because that is what is used by
//   the rockets in the T_RadiusDamage() function call above.  Feel free
//   to alter it to taste)
    ptr=findradius(self.origin, 150);

//  set this rockets lip value
    ptr.lip=1234.0;

//  The list is returned to us in a linked-list fashion.  Put simply; if there
//  are no entities found, ptr is zero (or false). If there is at least one
//  entity found, ptr will refer to it.
    while(ptr){
//      here we check to see if the entity is of class "grenade", and that
//      we haven't found a grenade with a set lip value.  Notice that we
//      don't check for self any more?  We don't need to anymore because we
//      set our own lip value before entering this section of code.
        if((ptr.classname=="grenade") && (ptr.lip!=1234.0)){
//          if both these conditions are true, set the nextthink time of the
//          entity to the current game time, and make sure the think function
//          of the entity is referring to the GrenadeExplode() function.
            ptr.nextthink=time;
            ptr.think=GrenadeExplode;
        }
        else if((ptr.classname=="missile") && (ptr.lip!=1234.0)){
//          if both these conditions are true, set the nextthink time of the
//          entity to the current game time, and make sure the think function
//          of the entity is referring to the RocketExplode() function.
            ptr.nextthink=time;
            ptr.think=RocketExplode;
        }
        else if((ptr.classname=="mine") && (ptr.lip!=1234.0)){
//          if both these conditions are true, set the nextthink time of the
//          entity to the current game time, and make sure the think function
//          of the entity is referring to the GrenadeExplode() function.
            ptr.nextthink=time;
            ptr.think=MineExplode;
        }
//      By using the "chain" attribute of the entity we can find the next
//      entity in the list of entity's found by the findradius() function.
        ptr=ptr.chain;
    }

//  finally become an explosion, just as before

	BecomeExplosion ();
}

void() T_MissileTouch =
{
	local float	damg;

	if (other == self.owner)
		return;		// don't explode on owner

	if (pointcontents(self.origin) == CONTENT_SKY)
	{
		remove(self);
		return;
	}

	damg = 100 + random()*20;
	
	if (other.health)
	{
		if (other.classname == "monster_shambler")
			damg = damg * 0.5;	// mostly immune
		T_Damage (other, self, self.owner, damg );
	}

	self.effects = self.effects - (self.effects & EF_REDLIGHT);
	RocketExplode();
};

void() RocketSpeedChange =
{
	if (vlen(self.velocity) < 2000)
	{
		self.velocity = self.velocity * 1.5;
		self.nextthink = time + 0.2;
		self.think = RocketSpeedChange;
	}
	else
	{
		self.nextthink = time + 5;
		self.think = SUB_Remove;
	}
}

/*
================
W_FireRocket
================
*/
void() W_FireRocket =
{
	local	entity missile, mpuff;

	if (!deathmatch & DM_INFINITE_AMMO)
		self.currentammo = self.ammo_rockets1 = self.ammo_rockets1 - 1;

	UpdateAmmoCounts(self);

	sound (self, CHAN_WEAPON, "weapons/sgun1.wav", 1, ATTN_NORM);

	self.punchangle_x = -3;

	missile = spawn ();
	missile.owner = self;
	missile.movetype = MOVETYPE_FLYMISSILE;
	missile.solid = SOLID_BBOX;
	missile.classname = "missile";

// set missile speed

	makevectors (self.v_angle);
	missile.velocity = aim(self, 1000);
	missile.velocity = missile.velocity * 250;
	missile.angles = vectoangles(missile.velocity);

	missile.touch = T_MissileTouch;

// set missile duration

	missile.nextthink = time + 0.1;
	missile.think = RocketSpeedChange;

	setmodel (missile, "progs/missile.mdl");
	setsize (missile, '0 0 0', '0 0 0');		
	setorigin (missile, self.origin + v_forward*8 + v_right*9 + '0 0 22');
};

//////////////////////////////////////////////////////
//				GUIDED MISSILE CODE                 //
//////////////////////////////////////////////////////

void() PlayerDie;
void() T_GMissileTouch;
//void() player_pain;
void() player_changeup;

void() clone_pain =
{
	T_Damage(self.owner,self,self,0);
	self.owner.dmg_take = self.dmg_take;
	self.owner.dmg_save = self.dmg_save;
	self.owner.dmg_inflictor = self.dmg_inflictor;
	self.owner.health = self.health;
	self.owner.armorvalue = self.armorvalue;
	self.owner.armortype = self.armortype;
//	player_pain();
};

void() CloneDie =
{
	local entity    play;
    play = self.owner;
    self = play.mymissile;
    other = world;
//    sprint(play,"about to touch ");
//    sprint(play,play.classname);
//    sprint(play,"\n");

    if (play.classname != "player")
		T_GMissileTouch();

	self = play;
    PlayerDie();
};

void() T_GMissileTouch =
{
	local float	damg;

	if ((other == self.owner) /*|| (other == self.owner.clone)*/)
		return;

    if (other == self.owner.clone)
		other = self.owner;
/*
	sprint(self.owner,self.classname);
	sprint(self.owner," touch ");
	sprint(self.owner,other.classname);
	sprint(self.owner,"\n");
*/
	self.owner.classname = "player";
    self.owner.weaponmodel = self.owner.clone.weaponmodel;
    self.owner.weaponframe = 0;
    setmodel(self.owner, self.owner.clone.model);
    self.owner.frame = self.owner.clone.frame;
    self.owner.takedamage = DAMAGE_AIM;
    self.owner.solid = SOLID_SLIDEBOX;
    self.owner.view_ofs = '0 0 26';
    setsize (self.owner, VEC_HULL_MIN, VEC_HULL_MAX);
    self.owner.origin = self.owner.clone.origin;
    self.owner.velocity = self.owner.clone.velocity;
    self.owner.armorvalue = self.owner.clone.armorvalue;
    self.owner.armortype = self.owner.clone.armortype;
    self.owner.flags = self.owner.flags - self.owner.flags && FL_NOTARGET;
    self.owner.v_angle = self.owner.clone.v_angle;
    self.owner.angles = self.owner.clone.angles;
    self.owner.health = self.owner.clone.health;
    self.owner.flags = self.owner.clone.flags;
    self.owner.invisible_time = self.owner.clone.invisible_time;
    self.owner.invisible_finished = self.owner.clone.invisible_finished;
    self.owner.invincible_time = self.owner.clone.invincible_time;
    self.owner.invincible_finished = self.owner.clone.invincible_finished;
    self.owner.super_time = self.owner.clone.super_time;
    self.owner.super_damage_finished = self.owner.clone.super_damage_finished;
    self.owner.rad_time = self.owner.clone.rad_time;
    self.owner.radsuit_finished = self.owner.clone.radsuit_finished;
    self.owner.waterlevel = 0;
    self.owner.watertype = self.owner.clone.watertype;
    SetViewAngle(self.owner,self.owner.clone.v_angle);
    setmodel(self.owner.clone,"");
    self.owner.clone.solid = SOLID_NOT;
    self.owner.clone.takedamage = DAMAGE_NO;
    damg = 50 + random()*50;

	self.owner.chase_missile = 0;
	stuffcmd(self.owner,"chase_active 0\n");
	self.owner.attack_finished = time + 0.8;

	if (other.health)
	{
		if (other.classname == "monster_shambler")
			damg = damg * 0.5;	// mostly immune
	}

	T_Damage (other, self, self.owner, damg );
    T_RadiusDamage (self, self.owner, 90, other);

	if (pointcontents(self.origin) == CONTENT_SKY)
	{
		remove(self);
		return;
	}

    sound (self, CHAN_WEAPON, "weapons/r_exp3.wav", 1, ATTN_NORM);
	self.origin = self.origin - 8*normalize(self.velocity);

    BecomeExplosion ();
};



/*
================
W_FireRocket
================
*/
void() GuideThink;

void() W_FireMissile =
{
	local	entity missile, mpuff;

	if (!deathmatch & DM_INFINITE_AMMO)
		self.currentammo = self.ammo_rockets1 = self.ammo_rockets1 - 1;

	UpdateAmmoCounts(self);

	sound (self, CHAN_WEAPON, "weapons/sgun1.wav", 1, ATTN_NORM);

//	self.punchangle_x = 0;

	missile = spawn ();
	missile.owner = self;
	missile.movetype = MOVETYPE_FLYMISSILE;
	missile.solid = SOLID_BBOX;

// set missile speed

	makevectors (self.v_angle);
	missile.velocity = aim(self, 1000);
    missile.velocity = missile.velocity * 350;
	missile.angles = vectoangles(missile.velocity);

    missile.touch = T_GMissileTouch;

    missile.nextthink = time + 0.01;
    missile.think = GuideThink;

    	self.clone.armorvalue = self.armorvalue;
        self.clone.armortype = self.armortype;
        self.clone.health = 100;
        self.flags = self.flags || FL_NOTARGET;
        self.clone.origin = self.origin;
        self.clone.angles = self.angles;
        self.clone.v_angle = self.v_angle;
        setmodel(self.clone,"progs/p_pistol.mdl");
        self.clone.frame = 28;
        self.clone.takedamage = DAMAGE_AIM;
        self.clone.health = self.health;
        self.clone.max_health = self.max_health;
        self.clone.solid = SOLID_SLIDEBOX;
        self.clone.weaponmodel = self.weaponmodel;
        self.clone.th_pain = clone_pain;
        self.clone.th_die = CloneDie;
        self.clone.colormap = self.colormap;
        self.clone.weapon = self.weapon;
        self.clone.movetype = MOVETYPE_STEP;
        self.clone.velocity = self.velocity;
        self.clone.nextthink = self.nextthink;
        self.clone.think = self.think;
        self.clone.effects = self.effects | EF_DIMLIGHT;
        self.clone.flags = self.flags;
        self.clone.waterlevel = self.waterlevel;
        self.clone.watertype = self.watertype;
        self.clone.invisible_time = self.invisible_time;
        self.clone.invisible_finished = self.invisible_finished;
        self.clone.invincible_time = self.invincible_time;
        self.clone.invincible_finished = self.invincible_finished;
        self.clone.super_time = self.super_time;
        self.clone.super_damage_finished = self.super_damage_finished;
        self.clone.rad_time = self.rad_time;
        self.clone.radsuit_finished = self.radsuit_finished;
        setsize (self.clone, VEC_HULL_MIN, VEC_HULL_MAX);
        setmodel (missile, "progs/missile.mdl");
		setsize (missile, '0 0 0', '0 0 0');
        setorigin (missile, self.origin + v_forward*24 + '0 0 16');
        setmodel(self, "");
        setsize(self, '0 0 0', '0 0 0');
        self.solid = SOLID_NOT;
        self.view_ofs = '0 0 0';
        self.weaponmodel = "";
        missile.classname = "gmissile";
        self.classname = "gplayer";
        self.mymissile = missile;
        setorigin(self,self.origin +v_forward*1000);

		self.chase_missile = 1;
		stuffcmd(self,"chase_active 1\n");
};

void() CheckPowerups;

void() GuideThink =
{
	local float dot;
	self.owner.clone.frame = 28;

    local entity temp;
    temp = self;
    self = self.owner.clone;
    droptofloor();
    self = temp;
    self.angles = self.owner.v_angle;
    makevectors(self.angles);
/*
		// check if I'm turning
		dot = self.mangle * self.owner.v_angle;
		if(dot < 0.95) // if I've turned too much
		{
			self.velocity = normalize(v_forward) * (50);
		}
		else
            self.velocity = normalize(v_forward) * (250);

		// track last angle
		self.mangle = self.owner.v_angle;
*/
		self.velocity = normalize(v_forward) * (250);
        self.angles_x = 0-self.angles_x;
        makevectors(self.angles);
        self.owner.origin = self.origin - normalize(self.velocity)*5;
        self.nextthink = time + 0.01;
        self.think = GuideThink;

		if (pointcontents(self.origin) == CONTENT_SKY)
		{
			other = world;
			T_GMissileTouch();
		}

        if ( !(self.owner.flags & FL_JUMPRELEASED) )
			return;		// don't pogo stick

        if (self.owner.button2)
		{
        	self.owner.flags = self.owner.flags-self.owner.flags|FL_JUMPRELEASED;
        	other = world;
            T_GMissileTouch();
        }
};

/*
===============================================================================
Lightning Gun
===============================================================================
*/

/*
=================
LightningDamage
=================
*/
void(vector p1, vector p2, entity from, float damage) LightningDamage =
{
	local entity		e1, e2;
	local vector		f;
	
	f = p2 - p1;
	normalize (f);
	f_x = 0 - f_y;
	f_y = f_x;
	f_z = 0;
	f = f*16;

	e1 = e2 = world;

	traceline (p1, p2, FALSE, self);
	if (trace_ent.takedamage)
	{
		particle (trace_endpos, '0 0 100', 225, damage*4);
		T_Damage (trace_ent, from, from, damage);
		if (self.classname == "player")
		{
			if (other.classname == "player")
				trace_ent.velocity_z = trace_ent.velocity_z + 400;
		}
	}
	e1 = trace_ent;

	traceline (p1 + f, p2 + f, FALSE, self);
	if (trace_ent != e1 && trace_ent.takedamage)
	{
		particle (trace_endpos, '0 0 100', 225, damage*4);
		T_Damage (trace_ent, from, from, damage);
	}
	e2 = trace_ent;

	traceline (p1 - f, p2 - f, FALSE, self);
	if (trace_ent != e1 && trace_ent != e2 && trace_ent.takedamage)
	{
		particle (trace_endpos, '0 0 100', 225, damage*4);
		T_Damage (trace_ent, from, from, damage);
	}
};


void() W_FireLightning =
{
	local	vector		org;
	local	float		cells;

	if (self.ammo_cells1 < 1)
	{
		self.weapon = W_BestWeapon ();
		W_SetCurrentAmmo ();
		return;
	}

// explode if under water
	if (self.waterlevel > 1)
	{
		cells = self.ammo_cells1;
		self.ammo_cells1 = 0;
		W_SetCurrentAmmo ();
		T_RadiusDamage (self, self, 35*cells, world);
		return;
	}

	if (self.t_width < time)
	{
		sound (self, CHAN_WEAPON, "weapons/lhit.wav", 1, ATTN_NORM);
		self.t_width = time + 0.6;
	}
	self.punchangle_x = -2;

	self.currentammo = self.ammo_cells1 = self.ammo_cells1 - 1;
	UpdateAmmoCounts(self);

	org = self.origin + '0 0 16';
	
	traceline (org, org + v_forward*600, TRUE, self);

	WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
	WriteByte (MSG_BROADCAST, TE_LIGHTNING1);
	WriteEntity (MSG_BROADCAST, self);
	WriteCoord (MSG_BROADCAST, org_x);
	WriteCoord (MSG_BROADCAST, org_y);
	WriteCoord (MSG_BROADCAST, org_z);
	WriteCoord (MSG_BROADCAST, trace_endpos_x);
	WriteCoord (MSG_BROADCAST, trace_endpos_y);
	WriteCoord (MSG_BROADCAST, trace_endpos_z);

	LightningDamage (self.origin, trace_endpos + v_forward*4, self, 30);
};

//==============================================================================
// Grenade Launcher
//==============================================================================

void() GrenadeExplode =
{
    local entity ptr;

	T_RadiusDamage (self, self.owner, 120, world);

	WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
	WriteByte (MSG_BROADCAST, TE_EXPLOSION);
	WriteCoord (MSG_BROADCAST, self.origin_x);
	WriteCoord (MSG_BROADCAST, self.origin_y);
	WriteCoord (MSG_BROADCAST, self.origin_z);
	WriteCoord (MSG_BROADCAST, 1.0); // Red explosion colour
	WriteCoord (MSG_BROADCAST, 0.5); // Green explosion colour
	WriteCoord (MSG_BROADCAST, 0.0); // Blue explosion colour

//  call "findradius" to return list of entity's found
//  (I have chosen to use a radius of 120 because that is what is used by
//   the grenades in the T_RadiusDamage() function call above.  Feel free
//   to alter it to taste)
    ptr=findradius(self.origin, 120);

//  set this grenades lip value
    ptr.lip=1234.0;

//  The list is returned to us in a linked-list fashion.  Put simply; if there
//  are no entities found, ptr is zero (or false). If there is at least one
//  entity found, ptr will refer to it.
    while(ptr){
//      here we check to see if the entity is of class "grenade", and that
//      we haven't found a grenade with a set lip value.  Notice that we
//      don't check for self any more?  We don't need to anymore because we
//      set our own lip value before entering this section of code.
        if((ptr.classname=="grenade") && (ptr.lip!=1234.0)){
//          if both these conditions are true, set the nextthink time of the
//          entity to the current game time, and make sure the think function
//          of the entity is referring to the GrenadeExplode() function.
            ptr.nextthink=time;
            ptr.think=GrenadeExplode;
        }
        else if((ptr.classname=="missile") && (ptr.lip!=1234.0)){
//          if both these conditions are true, set the nextthink time of the
//          entity to the current game time, and make sure the think function
//          of the entity is referring to the GrenadeExplode() function.
            ptr.nextthink=time;
            ptr.think=RocketExplode;
        }
        else if((ptr.classname=="mine") && (ptr.lip!=1234.0)){
//          if both these conditions are true, set the nextthink time of the
//          entity to the current game time, and make sure the think function
//          of the entity is referring to the GrenadeExplode() function.
            ptr.nextthink=time;
            ptr.think=MineExplode;
        }
//      By using the "chain" attribute of the entity we can find the next
//      entity in the list of entity's found by the findradius() function.
        ptr=ptr.chain;
    }

//  finally become an explosion, just as before

	BecomeExplosion ();
};

void() GrenadeTouch =
{
	if (other == self.owner)
		return;		// don't explode on owner

	if (pointcontents(self.origin) == CONTENT_SKY)
	{
		remove(self);
		return;
	}

	if (other.takedamage == DAMAGE_AIM)
	{
		GrenadeExplode();
		return;
	}
	sound (self, CHAN_WEAPON, "weapons/bounce.wav", 1, ATTN_NORM);	// bounce sound
	if (self.velocity == '0 0 0')
		self.avelocity = '0 0 0';
};

/*
================
W_PlasmaBall
================
*/
void() W_PlasmaBall =
{
	local	entity missile;

	if (!deathmatch & DM_INFINITE_AMMO)
		self.currentammo = self.ammo_rockets1 = self.ammo_rockets1 - 1;
	UpdateAmmoCounts(self);

	sound (self, CHAN_WEAPON, "weapons/sgun1.wav", 1, ATTN_NORM);

	self.punchangle_x = -3;

	missile = spawn ();
	missile.owner = self;
	missile.movetype = MOVETYPE_FLYMISSILE;
	missile.solid = SOLID_BBOX;
	missile.classname = "missile";
	missile.effects = missile.effects | EF_REDLIGHT;

// set missile speed	

	makevectors (self.v_angle);
	missile.velocity = aim(self, 1000);
	missile.velocity = missile.velocity * 250;
	missile.angles = vectoangles(missile.velocity);

	missile.touch = T_MissileTouch;

// set missile duration
	missile.nextthink = time + 30;
	missile.think = SUB_Remove;

	setmodel (missile, "progs/s_laser.spr");
	setsize (missile, '0 0 0', '0 0 0');
	setorigin (missile, self.origin + v_forward*8 + v_right*9 + '0 0 22');
};

/*
================
W_FireGrenade
================
*/
void() W_FireGrenade =
{
	local	entity missile, mpuff;
	
	if (!deathmatch & DM_INFINITE_AMMO)
		self.currentammo = self.ammo_rockets1 = self.ammo_rockets1 - 1;
	UpdateAmmoCounts(self);

	sound (self, CHAN_WEAPON, "weapons/grenade.wav", 1, ATTN_NORM);

	self.punchangle_x = -3;

	missile = spawn ();
	missile.owner = self;
	missile.movetype = MOVETYPE_BOUNCE;
	missile.solid = SOLID_BBOX;
	missile.classname = "grenade";
		
// set missile speed

	makevectors (self.v_angle);

	if (self.v_angle_x)
		missile.velocity = v_forward*600 + v_up * 200 + crandom()*v_right*10 + crandom()*v_up*10;
	else
	{
		missile.velocity = aim(self, 1000);
		missile.velocity = missile.velocity * 600;
		missile.velocity_z = 200;
	}

	missile.avelocity = '300 300 300';

	missile.angles = vectoangles(missile.velocity);
	
	missile.touch = GrenadeTouch;
	
// set missile duration
	missile.nextthink = time + 3;
	missile.think = GrenadeExplode;

	setmodel (missile, "progs/grenade.mdl");
	setsize (missile, '0 0 0', '0 0 0');		
	setorigin (missile, self.origin + v_forward*8 + v_right*10 + '0 0 15');
};

//==============================================================================
// Remote Mines
//==============================================================================

void() MineExplode =
{
    self.th_die = SUB_Null;         // switched to null to avoid chain reaction when exploding (repeatedly kills itself!)
    self.takedamage = DAMAGE_NO;
            
	T_RadiusDamage (self, self.owner, 100, world);

	WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
	WriteByte (MSG_BROADCAST, TE_EXPLOSION);
	WriteCoord (MSG_BROADCAST, self.origin_x);
	WriteCoord (MSG_BROADCAST, self.origin_y);
	WriteCoord (MSG_BROADCAST, self.origin_z);
	WriteCoord (MSG_BROADCAST, 1.0); // Red explosion colour
	WriteCoord (MSG_BROADCAST, 0.5); // Green explosion colour
	WriteCoord (MSG_BROADCAST, 0.0); // Blue explosion colour

	BecomeExplosion ();
};

void() Detonate =
{
    
    local entity    missile; //Declares the float missile

    sound (self, CHAN_AUTO, "weapons/detonate.wav", 1, ATTN_NORM);

    missile = findradius (self.origin, 10000); //Finds everything within a 10000 radius
    while(missile) //Loops through everything put in the missile entity
    {
        if((missile.classname == "mine") && (missile.owner == self)) //Checks owner
        {
            missile.think = MineExplode;
            missile.nextthink = time; //sends the message that it is time to react
        }
        missile = missile.chain; //links every mine found so they all go BOOM!
    }
};

void () MineStick =
{

	local vector org;
    local vector targ;

//	makevectors (self.angles);
    org = self.origin + self.view_ofs;
    targ = org + v_forward * 10000;
    traceline(org, targ, FALSE, self);


	if ((self.enemy.classname == "monster_demon1") ||
		(self.enemy.classname == "monster_rex") ||
		(self.enemy.classname == "monster_tiger") ||
		(self.enemy.classname == "monster_army"))
	{
		setsize (self, '0 0 0', '0 0 0');
		self.origin = self.enemy.origin + '0 0 16';
		self.angles = self.enemy.angles;
		self.movetype = MOVETYPE_NONE;
		if (self.velocity == VEC_ORIGIN)
			self.avelocity = VEC_ORIGIN;
	}

	else if ((self.enemy.classname == "func_button") ||
			(self.enemy.classname == "mine") ||
			(self.enemy.classname == "func_door") ||
			(self.enemy.classname == "func_rotate_door") ||
			(self.enemy.classname == "func_glass"))
	{
		setsize (self, '-2 -2 -2', '2 2 2');

		if ((self.flags & FL_ONGROUND))
			self.angles = '90 0 0';
		else
		   	self.angles = vectoangles(trace_plane_normal);

		self.velocity = '0 0 0';
		self.avelocity = '0 0 0';
		self.movetype = MOVETYPE_NONE;

		return;
	}

	else if (self.enemy.classname == "player")
	{
		self.origin = self.enemy.origin;
		if (self.velocity == VEC_ORIGIN)
			self.avelocity = VEC_ORIGIN;
	}

	else if (trace_ent != world)
	{
		setsize (self, '0 0 0', '0 0 0');
	    self.angles = vectoangles(trace_plane_normal);
	  	self.velocity = (self.velocity * 0.5);
	    self.avelocity = '100 100 100';
	    self.movetype = MOVETYPE_TOSS;
	}

	else
	{
	    setsize (self, '-2 -2 -2', '2 2 2');

		if ((self.flags & FL_ONGROUND))
			self.angles = '90 0 0';
		else
		   	self.angles = vectoangles(trace_plane_normal);

		self.velocity = '0 0 0';
		self.avelocity = '0 0 0';
	    self.movetype = MOVETYPE_NONE;

		return;
	}

	self.think = MineStick;
	self.touch = MineStick;
	self.nextthink = (time + 0.100);

};

void() MineTouch =
{

//	if (other == self.owner)
//		return;
	if (other.classname == "player")
	{
		// Tell the attacker the mine stuck on to a target
    	frik_big_centerprint(self.owner,"Remote mine sticked ",other.netname,"!","","","","");

		// Tell the target he's been mine stuck
    	centerprint(other,"You've been remote mine sticked!");
	}

	if (pointcontents(self.origin) == CONTENT_SKY)
	{
		remove(self);
		return;
	}

    sound (self, CHAN_WEAPON, "weapons/bounce.wav", 1, ATTN_NORM);

	self.think = MineStick;
  	self.touch = MineStick; // go to MineStick when touching something
  	self.nextthink = time + 0.1;
  	self.velocity = self.velocity * 0;
  	self.avelocity = VEC_ORIGIN;
  	self.enemy = other;

};

/*
================
W_ThrowMine
================
*/
void() W_ThrowMine =
{

    if (self.ammo_cells1 == 0)
    {
       sprint (self, "You have no remote mines\n");
       return;
    }
    
	local	entity missile;

	if (!deathmatch & DM_INFINITE_AMMO)
		self.currentammo = self.ammo_cells1 = self.ammo_cells1 - 1;
	UpdateAmmoCounts(self);

	missile = spawn ();
	missile.owner = self;
	missile.movetype = MOVETYPE_BOUNCE;
	missile.solid = SOLID_BBOX;
	missile.classname = "mine";
    missile.th_die = MineExplode;

// set missile speed

	makevectors (self.v_angle);

	if (self.v_angle_x)
		missile.velocity = v_forward*350 + v_up * 200;
	else
	{
		missile.velocity = aim(self, 1000);
		missile.velocity = missile.velocity * 350;
		missile.velocity_z = 200;
	}

	missile.avelocity = '300 300 300';
	missile.angles = vectoangles(missile.velocity);
	missile.touch = MineTouch;
	
// set missile duration
	missile.nextthink = time + 60;
	missile.think = Detonate;

	setmodel (missile, "progs/mine.mdl");
	setsize (missile, '0 0 0', '0 0 0');
	setorigin (missile, self.origin + v_forward*8 + v_right*10 + '0 0 15');
};

//=============================================================================

void() spike_touch;
void() superspike_touch;

void() arrow_touch;
void() arrow_f_touch;
void() arrow_point;
void() arrow_bounce;

// ARROWS

/*
================
W_FireArrow
================
*/
void(float v) W_FireArrow =
{
	local	entity arrow;

	sound (self, CHAN_WEAPON, "weapons/bowf.wav", 1, ATTN_NORM);

	arrow = spawn ();
	arrow.owner = self;
	arrow.movetype = MOVETYPE_FLYMISSILE;
	arrow.solid = SOLID_BBOX;
	arrow.classname = "spike";
		
// set arrow speed	

	makevectors (self.v_angle);
	arrow.velocity = aim(self, 1000);
	arrow.velocity = arrow.velocity * v;
	arrow.angles = vectoangles(arrow.velocity);

	
// set arrow fly function

	arrow.nextthink = time + 0.05;
	arrow.think = arrow_point;

	if ((self.secondary == 1) && (self.ammo_rockets >= 1))
	{
		if (!deathmatch & DM_INFINITE_AMMO)
			self.currentammo = self.ammo_rockets1 = self.ammo_rockets1 - 1;
	    setmodel (arrow, "progs/arrow_f.mdl");
	    arrow.touch = arrow_f_touch;
    }
	else
	{
	    setmodel (arrow, "progs/arrow.mdl");
	    arrow.touch = arrow_touch;
    }
    
	setsize (arrow, '0 0 0', '0 0 0');		
	setorigin (arrow, self.origin + '0 0 18');
};

void() arrow_point =
{
    if (vlen(self.velocity) < 2000)
    {
    	self.nextthink = time + 0.05;
	    self.angles = vectoangles(self.velocity);
	    self.movetype = MOVETYPE_TOSS;
    }
    else
    {
		if (coop || deathmatch & DM_DM_MASK)
  	    	self.nextthink = time + 5;
		else
  	    	self.nextthink = time + 15;
	    self.think = SUB_Remove;
    }
};

void() arrow_bounce =
{
	self.think = arrow_bounce;
    self.nextthink = time + 0.1;

	if (random() < 0.3)
	    self.avelocity = '300 -100 200';
	else if (random() < 0.6)
		self.avelocity = '-150 300 150';
	else
		self.avelocity = '200 100 -300';

	self.movetype = MOVETYPE_BOUNCE;

	if (vlen(self.velocity) == 0)
    {
		if (random() < 0.1)
			self.angles = '0 40 0';
		else if (random() < 0.2)
			self.angles = '0 80 0';
		else if (random() < 0.3)
			self.angles = '0 120 0';
		else if (random() < 0.4)
			self.angles = '0 160 0';
		else if (random() < 0.5)
			self.angles = '0 200 0';
		else if (random() < 0.6)
			self.angles = '0 240 0';
		else if (random() < 0.7)
			self.angles = '0 280 0';
		else if (random() < 0.8)
			self.angles = '0 320 0';
		else
			self.angles = '0 360 0';

		if (coop || deathmatch & DM_DM_MASK)
	  	    self.nextthink = time + 5;
		else
	  	    self.nextthink = time + 15;
	    self.think = SUB_Remove;
    }
};

void() arrow_touch =
{
	if (other == self.owner)
		return;		// don't hurt owner, but would be funny ...
		
	if (other.solid == SOLID_TRIGGER)
		return;	// trigger field, do nothing

	if (pointcontents(self.origin) == CONTENT_SKY)
	{
		remove(self);
		return;
	}

// hit something that bleeds
	if (other.takedamage)
	{
	    if (vlen(self.velocity) >= 1500)
		    T_Damage (other, self, self.owner, 20);
        else if (vlen(self.velocity) >= 750)
		    T_Damage (other, self, self.owner, 5);
        else
		    T_Damage (other, self, self.owner, 2);

		if(!trace_ent.classname == "func_glass")
			if(!trace_ent.classname == "func_door")
				if(!trace_ent.classname == "func_rotate_door")
					if(!trace_ent.classname == "func_button")
                    	if(!trace_ent.classname == "explo_box")
							BloodSplat();
        return;         //add this to avoid errors
	}

	if (vlen(self.velocity) < 750)
	{
		arrow_bounce();
		return;
	}

	WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
	WriteByte (MSG_BROADCAST, TE_GUNSHOT);
	WriteCoord (MSG_BROADCAST, self.origin_x);
	WriteCoord (MSG_BROADCAST, self.origin_y);
	WriteCoord (MSG_BROADCAST, self.origin_z);
	
    local vector org;
    local vector targ;

    org = self.origin + self.view_ofs;
    targ = org + v_forward * 10000;
    traceline(org, targ, FALSE, self);

	if (trace_ent != world)
	{
	    self.movetype = MOVETYPE_TOSS;
	}
	else
	{
		self.movetype = MOVETYPE_FLYMISSILE;
	    self.velocity = '0 0 0';
	}

	self.think = SUB_Remove;
	if (coop || deathmatch & DM_DM_MASK)
		self.nextthink = time + 5;
	else
		self.nextthink = time + 30;
};

void() ArrowExplode =
{

//	T_Damage (other, self, self.owner, 10 );
	T_RadiusDamage (self, self.owner, 70, world);

	WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
	WriteByte (MSG_BROADCAST, TE_EXPLOSION);
	WriteCoord (MSG_BROADCAST, self.origin_x);
	WriteCoord (MSG_BROADCAST, self.origin_y);
	WriteCoord (MSG_BROADCAST, self.origin_z);
	WriteCoord (MSG_BROADCAST, 1.0); // Red explosion colour
	WriteCoord (MSG_BROADCAST, 0.5); // Green explosion colour
	WriteCoord (MSG_BROADCAST, 0.0); // Blue explosion colour

	BecomeExplosion ();
};

void() arrow_f_touch =
{
	self.enemy = other;

	if (other == self.owner)
		return;		// don't hurt owner, but would be funny ...
		
	if (other.solid == SOLID_TRIGGER)
		return;	// trigger field, do nothing

	if (pointcontents(self.origin) == CONTENT_SKY)
	{
		remove(self);
		return;
	}

// hit something that bleeds
	if (other.takedamage == DAMAGE_AIM)
	{
	    ArrowExplode();
		remove(self);
		return;
	}

	WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
	WriteByte (MSG_BROADCAST, TE_GUNSHOT);
	WriteCoord (MSG_BROADCAST, self.origin_x);
	WriteCoord (MSG_BROADCAST, self.origin_y);
	WriteCoord (MSG_BROADCAST, self.origin_z);
	
    local vector org;
    local vector targ;

    org = self.origin + self.view_ofs;
    targ = org + v_forward * 10000;
    traceline(org, targ, FALSE, self);

	if (trace_ent != world)
	{
	    self.movetype = MOVETYPE_TOSS;
	}
	else
	{
		self.movetype = MOVETYPE_FLYMISSILE;
	    self.velocity = '0 0 0';
	}
	
	self.nextthink = time + 2;
	self.think = ArrowExplode;

};

/*
===============
launch_spike

Used for both the player and the ogre
===============
*/
void(vector org, vector dir) launch_spike =
{
	newmis = spawn ();
	newmis.owner = self;
	newmis.movetype = MOVETYPE_FLYMISSILE;
	newmis.solid = SOLID_BBOX;

	newmis.angles = vectoangles(dir);
	
	newmis.touch = spike_touch;
	newmis.classname = "spike";
	newmis.think = SUB_Remove;
	newmis.nextthink = time + 6;
	setmodel (newmis, "progs/spike.mdl");
	setsize (newmis, VEC_ORIGIN, VEC_ORIGIN);		
	setorigin (newmis, org);

	newmis.velocity = dir * 1000;
};

void() W_FireSuperSpikes =
{
	local vector	dir;
	local entity	old;
	
	sound (self, CHAN_WEAPON, "weapons/spike2.wav", 1, ATTN_NORM);
	self.attack_finished = time + 0.2;
	self.currentammo = self.ammo_nails1 = self.ammo_nails1 - 2;
	UpdateAmmoCounts(self);
	dir = aim (self, 1000);
	launch_spike (self.origin + '0 0 16', dir);
	newmis.touch = superspike_touch;
	setmodel (newmis, "progs/s_spike.mdl");
	setsize (newmis, VEC_ORIGIN, VEC_ORIGIN);		
	self.punchangle_x = -2;
};

void(float ox) W_FireSpikes =
{
	local vector	dir;
	local entity	old;
	
	makevectors (self.v_angle);
	
	if (self.ammo_nails1 >= 2 && self.weapon == IT_SUPER_NAILGUN)
	{
		W_FireSuperSpikes ();
		return;
	}

	if (self.ammo_nails1 < 1)
	{
		self.weapon = W_BestWeapon ();
		W_SetCurrentAmmo ();
		return;
	}

	sound (self, CHAN_WEAPON, "weapons/rocket1i.wav", 1, ATTN_NORM);
	self.attack_finished = time + 0.2;
	self.currentammo = self.ammo_nails1 = self.ammo_nails1 - 1;
	UpdateAmmoCounts(self);
	dir = aim (self, 1000);
	launch_spike (self.origin + '0 0 16' + v_right*ox, dir);

	self.punchangle_x = -2;
};

.float hit_z;
void() spike_touch =
{
local float rand;
	if (other == self.owner)
		return;

	if (other.solid == SOLID_TRIGGER)
		return;	// trigger field, do nothing

	if (pointcontents(self.origin) == CONTENT_SKY)
	{
		remove(self);
		return;
	}
	
// hit something that bleeds
	if (other.takedamage)
	{
		spawn_touchblood (9, other);
		T_Damage (other, self, self.owner, 9);
	}
	else
	{
		WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
		
		if (self.classname == "wizspike")
			WriteByte (MSG_BROADCAST, TE_WIZSPIKE);
		else if (self.classname == "knightspike")
			WriteByte (MSG_BROADCAST, TE_KNIGHTSPIKE);
		else
			WriteByte (MSG_BROADCAST, TE_SPIKE);
		WriteCoord (MSG_BROADCAST, self.origin_x);
		WriteCoord (MSG_BROADCAST, self.origin_y);
		WriteCoord (MSG_BROADCAST, self.origin_z);
	}

	remove(self);

};

void() superspike_touch =
{
local float rand;
	if (other == self.owner)
		return;

	if (other.solid == SOLID_TRIGGER)
		return;	// trigger field, do nothing

	if (pointcontents(self.origin) == CONTENT_SKY)
	{
		remove(self);
		return;
	}
	
// hit something that bleeds
	if (other.takedamage)
	{
		spawn_touchblood (18, other);
		T_Damage (other, self, self.owner, 18);
	}
	else
	{
		WriteByte (MSG_BROADCAST, SVC_TEMPENTITY);
		WriteByte (MSG_BROADCAST, TE_SUPERSPIKE);
		WriteCoord (MSG_BROADCAST, self.origin_x);
		WriteCoord (MSG_BROADCAST, self.origin_y);
		WriteCoord (MSG_BROADCAST, self.origin_z);
	}

	remove(self);

};

/*
===============================================================================

PLAYER WEAPON USE

===============================================================================
*/

/*
===============
WeaponName - Prints Weapon Name
===============
*/
void() WeaponName =
{

        if (self.weapon == IT_AXE)
	       sound (self, CHAN_ITEM, "weapons/knife.wav", 1, ATTN_STATIC);
//        else if (self.weapon == IT_TEKBOW)
//	       sound (self, CHAN_ITEM, "weapons/knife.wav", 1, ATTN_STATIC);
        else if (self.weapon == IT_SHOTGUN)
	       sound (self, CHAN_ITEM, "weapons/pkup.wav", 1, ATTN_STATIC);
        else if (self.weapon == IT_NAILGUN)
	       sound (self, CHAN_ITEM, "weapons/pkup.wav", 1, ATTN_STATIC);
        else if (self.weapon == IT_UZI)
	       sound (self, CHAN_ITEM, "weapons/pkup.wav", 1, ATTN_STATIC);
        else if (self.weapon == IT_M99)
	       sound (self, CHAN_ITEM, "weapons/pkup.wav", 1, ATTN_STATIC);
        else if (self.weapon == IT_SUPER_NAILGUN)
	       sound (self, CHAN_ITEM, "weapons/pkup.wav", 1, ATTN_STATIC);
        else if (self.weapon == IT_SUPER_SHOTGUN)
	       sound (self, CHAN_ITEM, "weapons/pkup.wav", 1, ATTN_STATIC);
        else if (self.weapon == IT_GRENADE_LAUNCHER)
	       sound (self, CHAN_ITEM, "weapons/pkup.wav", 1, ATTN_STATIC);
        else if (self.weapon == IT_ROCKET_LAUNCHER)
	       sound (self, CHAN_ITEM, "weapons/pkup.wav", 1, ATTN_STATIC);
        else if (self.weapon == IT_LIGHTNING)
	       sound (self, CHAN_ITEM, "weapons/mines.wav", 1, ATTN_STATIC);

	local string weapname;

	if (self.weapon == IT_AXE)weapname = "\bKnife";
	else if (self.weapon == IT_TEKBOW)
		if (self.secondary == 1)
			weapname = "\bTek Bow";
		else
			weapname = "\bNormal Bow";
	else if (self.weapon == IT_SHOTGUN)weapname = "\bPistol";
	else if (self.weapon == IT_SUPER_SHOTGUN)weapname = "\bShotgun";
	else if (self.weapon == IT_NAILGUN)weapname = "\bAssualt Rifle";
	else if (self.weapon == IT_UZI)weapname = "\bUzi";
	else if (self.weapon == IT_M99)weapname = "\bSniper Rifle";
	else if (self.weapon == IT_SUPER_NAILGUN)weapname = "\bMini Gun";
	else if (self.weapon == IT_GRENADE_LAUNCHER)
		if (self.secondary == 1)
			weapname = "\bPlasma Launcher";
		else
			weapname = "\bGrenade Launcher";
	else if (self.weapon == IT_ROCKET_LAUNCHER)
		if (self.secondary == 1)
			weapname = "\bGuided Rocket Launcher";
		else
			weapname = "\bRocket Launcher";
	else if (self.weapon == IT_LIGHTNING)weapname = "\bRemote Mines";

	sprint (self, "Selected ");
	sprint (self, weapname);
	sprint (self, "\n");

};

/*
===============
W_SetCurrentWeapon
===============
*/
void() W_SetCurrentWeapon =
{

//	if(self.deadflag != DEAD_NO)
//		return;

	if (self.health <= 0)
		return;

	self.items = self.items - ( self.items & (IT_SHELLS | IT_NAILS | IT_ROCKETS | IT_CELLS) );
	self.items2 = self.items2 - ( self.items2 & (IT2_50CAL | IT2_60CAL) );

//	self.weaponmodel = "";
	self.zoomtoggle = 0;

	if (self.weapon == IT_AXE)
	{
		self.currentammo = 0;
		stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");

//		if (self.ccamera != TRUE)
		    self.weaponmodel = "progs/v_axe.mdl";

		self.weaponframe = 0;
		self.zoom = 1;
	}
	else if (self.weapon == IT_TEKBOW)
	{
		if ((self.secondary == 1) && (self.ammo_rockets >= 1))
        {
		    self.currentammo = self.ammo_rockets1;
		    self.items = self.items | IT_ROCKETS;
//		    if (self.ccamera != TRUE)
		        self.weaponmodel = "progs/v_tekbow.mdl";
        }
        else
        {
		    self.currentammo = 0;
//		    if (self.ccamera != TRUE)
		        self.weaponmodel = "progs/v_bow.mdl";
        }

		stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");

        self.weaponframe = 0;
		self.zoom = 2;
	}
	else if (self.weapon == IT_SHOTGUN)
	{
		if (deathmatch & DM_NO_RELOAD)
			self.currentammo = self.ammo_nails1;
		else
			self.currentammo = self.bulletclip;

		stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");

//		if (self.ccamera != TRUE)
		    self.weaponmodel = "progs/v_shot.mdl";
		self.weaponframe = 0;
		self.zoom = 2;
		self.items = self.items | IT_NAILS;
	}
	else if (self.weapon == IT_SUPER_SHOTGUN)
	{
		self.currentammo = self.ammo_shells1;

		stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");

//		if (self.ccamera != TRUE)
		    self.weaponmodel = "progs/v_shot2.mdl";
		self.weaponframe = 0;
		self.zoom = 1;
		self.items = self.items | IT_SHELLS;
	}
	else if (self.weapon == IT_NAILGUN)
	{
		if (deathmatch & DM_NO_RELOAD)
			self.currentammo = self.ammo_nails1;
		else
			self.currentammo = self.rifleclip;

		stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");

//		if (self.ccamera != TRUE)
		    self.weaponmodel = "progs/v_nail.mdl";
		self.weaponframe = 0;
		self.zoom = 2;
		self.items = self.items | IT_NAILS;
	}

	else if (self.weapon == IT_UZI)
	{
		if (deathmatch & DM_NO_RELOAD)
			self.currentammo = self.ammo_nails1;
		else
			self.currentammo = self.uziclip;

		stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");

//		if (self.ccamera != TRUE)
		    self.weaponmodel = "progs/v_uzi.mdl";
		self.weaponframe = 0;
		self.zoom = 1;
		self.items = self.items | IT_NAILS;
	}

	else if (self.weapon == IT_M99)
	{
		self.currentammo = self.ammo_50cal;

		stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 0\n");

//		if (self.ccamera != TRUE)
		    self.weaponmodel = "progs/v_sniper.mdl";
		self.weaponframe = 0;
		self.zoom = 3;
		self.items2 = self.items2 | IT2_50CAL;
	}

	else if (self.weapon == IT_SUPER_NAILGUN)
	{
		self.currentammo = self.ammo_nails1;

		stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");

//		if (self.ccamera != TRUE)
		    self.weaponmodel = "progs/v_nail2.mdl";
		self.weaponframe = 0;
		self.zoom = 1;
		self.items = self.items | IT_NAILS;
	}
	else if (self.weapon == IT_GRENADE_LAUNCHER)
	{
		self.currentammo = self.ammo_rockets1;

		stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");

//		if (self.ccamera != TRUE)
		    self.weaponmodel = "progs/v_rock.mdl";
		self.weaponframe = 0;
		self.zoom = 1;
		self.items = self.items | IT_ROCKETS;
	}
	else if (self.weapon == IT_ROCKET_LAUNCHER)
	{
		self.currentammo = self.ammo_rockets1;

		stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");

//		if (self.ccamera != TRUE)
		    self.weaponmodel = "progs/v_rock2.mdl";
		self.weaponframe = 0;
		self.zoom = 1;
		self.items = self.items | IT_ROCKETS;
	}
	else if (self.weapon == IT_LIGHTNING)
	{
		self.currentammo = self.ammo_cells1;

		stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");

//		if (self.ccamera != TRUE)
//		    self.weaponmodel = "progs/v_light.mdl";
		    self.weaponmodel = "";
		self.weaponframe = 0;
		self.zoom = 1;
		self.items = self.items | IT_CELLS;
	}
	else
	{
		self.currentammo = 0;
		self.weaponmodel = "";
		self.weaponframe = 0;
		self.zoom = 0;
		stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");
	}

	UpdateAmmoCounts(self);

};

/*
===============
W_SetCurrentAmmo
===============
*/

void() W_SetAmmoOnly =
{
    if (self.aflag == 0)
	   player_run ();		// get out of any weapon firing states

	self.items = self.items - ( self.items & (IT_SHELLS | IT_NAILS | IT_ROCKETS | IT_CELLS) );

	self.items2 = self.items2 - ( self.items2 & (IT2_50CAL | IT2_60CAL) );

	if (self.weapon == IT_AXE)
		self.currentammo = 0;

	else if (self.weapon == IT_TEKBOW)
	{
		if ((self.secondary == 1) && (self.ammo_rockets1 >= 1))
        {
		    self.currentammo = self.ammo_rockets1;
		    self.items = self.items | IT_ROCKETS;
        }
        else
		    self.currentammo = 0;
	}
	else if (self.weapon == IT_SHOTGUN)
	{
		if (deathmatch & DM_NO_RELOAD)
			self.currentammo = self.ammo_nails1;
		else
			self.currentammo = self.bulletclip;
        self.items = self.items | IT_NAILS;
	}
	else if (self.weapon == IT_SUPER_SHOTGUN)
	{
		self.currentammo = self.ammo_shells1;
		self.items = self.items | IT_SHELLS;
	}
	else if (self.weapon == IT_NAILGUN)
	{
		if (deathmatch & DM_NO_RELOAD)
			self.currentammo = self.ammo_nails1;
		else
			self.currentammo = self.rifleclip;
		self.items = self.items | IT_NAILS;
	}
	else if (self.weapon == IT_UZI)
	{
		if (deathmatch & DM_NO_RELOAD)
			self.currentammo = self.ammo_nails1;
		else
			self.currentammo = self.uziclip;
		self.items = self.items | IT_NAILS;
	}
	else if (self.weapon == IT_M99)
	{
		self.currentammo = self.ammo_50cal;
		self.items2 = self.items2 | IT2_50CAL;
	}
	else if (self.weapon == IT_SUPER_NAILGUN)
	{
		self.currentammo = self.ammo_nails1;
		self.items = self.items | IT_NAILS;
	}
	else if (self.weapon == IT_GRENADE_LAUNCHER)
	{
		self.currentammo = self.ammo_rockets1;
		self.items = self.items | IT_ROCKETS;
	}
	else if (self.weapon == IT_ROCKET_LAUNCHER)
	{
		self.currentammo = self.ammo_rockets1;
		self.items = self.items | IT_ROCKETS;
	}
	else if (self.weapon == IT_LIGHTNING)
	{
		self.currentammo = self.ammo_cells1;
		self.items = self.items | IT_CELLS;
	}
	else
		self.currentammo = 0;

	UpdateAmmoCounts(self);
};

/*
===============
W_SetCurrentAmmo
===============
*/

void() W_SetCurrentAmmo =
{

//	if(self.deadflag != DEAD_NO)
//		return;

//	if (self.health <= 0)
//		return;

    if (self.aflag == 0)
	   player_run ();		// get out of any weapon firing states

	self.items = self.items - ( self.items & (IT_SHELLS | IT_NAILS | IT_ROCKETS | IT_CELLS) );

	self.items2 = self.items2 - ( self.items2 & (IT2_50CAL | IT2_60CAL) );

//	self.weaponmodel = "";
	self.zoomtoggle = 0;

	if (self.weapon == IT_AXE)
	{
		self.currentammo = 0;
		if (self.aflag == 0)
		{
			stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");
//			if (self.ccamera != TRUE)
		    	self.weaponmodel = "progs/v_axe.mdl";
			self.weaponframe = 0;
			self.zoom = 1;
        }
	}
	else if (self.weapon == IT_TEKBOW)
	{
		if ((self.secondary == 1) && (self.ammo_rockets1 >= 1))
        {
		    self.currentammo = self.ammo_rockets1;
		    self.items = self.items | IT_ROCKETS;
//		    if (self.ccamera != TRUE)
		        self.weaponmodel = "progs/v_tekbow.mdl";
        }
        else
        {
		    self.currentammo = 0;
//		    if (self.ccamera != TRUE)
		        self.weaponmodel = "progs/v_bow.mdl";
        }
		if (self.aflag == 0)
		{
			stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");
	        self.weaponframe = 0;
			self.zoom = 2;
        }
	}
	else if (self.weapon == IT_SHOTGUN)
	{
		if (deathmatch & DM_NO_RELOAD)
			self.currentammo = self.ammo_nails1;
		else
			self.currentammo = self.bulletclip;
        self.items = self.items | IT_NAILS;
		if (self.aflag == 0)
		{
			stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");
//			if (self.ccamera != TRUE)
			    self.weaponmodel = "progs/v_shot.mdl";
			self.weaponframe = 0;
			self.zoom = 2;
        }
	}
	else if (self.weapon == IT_SUPER_SHOTGUN)
	{
		self.currentammo = self.ammo_shells1;
		self.items = self.items | IT_SHELLS;
		if (self.aflag == 0)
		{
			stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");
//			if (self.ccamera != TRUE)
			    self.weaponmodel = "progs/v_shot2.mdl";
			self.weaponframe = 0;
			self.zoom = 1;
        }
	}
	else if (self.weapon == IT_NAILGUN)
	{
		if (deathmatch & DM_NO_RELOAD)
			self.currentammo = self.ammo_nails1;
		else
			self.currentammo = self.rifleclip;
		self.items = self.items | IT_NAILS;
		if (self.aflag == 0)
		{
			stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");
//			if (self.ccamera != TRUE)
			    self.weaponmodel = "progs/v_nail.mdl";
			self.weaponframe = 0;
			self.zoom = 2;
        }
	}

	else if (self.weapon == IT_UZI)
	{
		if (deathmatch & DM_NO_RELOAD)
			self.currentammo = self.ammo_nails1;
		else
			self.currentammo = self.uziclip;
		self.items = self.items | IT_NAILS;
		if (self.aflag == 0)
		{
			stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");
//			if (self.ccamera != TRUE)
			    self.weaponmodel = "progs/v_uzi.mdl";
			self.weaponframe = 0;
			self.zoom = 1;
        }
	}
	else if (self.weapon == IT_M99)
	{
		self.currentammo = self.ammo_50cal;
		self.items2 = self.items2 | IT2_50CAL;
		if (self.aflag == 0)
		{
			stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 0\n");
//			if (self.ccamera != TRUE)
			    self.weaponmodel = "progs/v_sniper.mdl";
			self.weaponframe = 0;
			self.zoom = 3;
        }
	}
	else if (self.weapon == IT_SUPER_NAILGUN)
	{
		self.currentammo = self.ammo_nails1;
		self.items = self.items | IT_NAILS;
		if (self.aflag == 0)
		{
			stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");
//			if (self.ccamera != TRUE)
			    self.weaponmodel = "progs/v_nail2.mdl";
			self.weaponframe = 0;
			self.zoom = 1;
        }
	}
	else if (self.weapon == IT_GRENADE_LAUNCHER)
	{
		self.currentammo = self.ammo_rockets1;
		self.items = self.items | IT_ROCKETS;
		if (self.aflag == 0)
		{
			stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");
//			if (self.ccamera != TRUE)
			    self.weaponmodel = "progs/v_rock.mdl";
			self.weaponframe = 0;
			self.zoom = 1;
        }
	}
	else if (self.weapon == IT_ROCKET_LAUNCHER)
	{
		self.currentammo = self.ammo_rockets1;
		self.items = self.items | IT_ROCKETS;
		if (self.aflag == 0)
		{
			stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");
//			if (self.ccamera != TRUE)
			    self.weaponmodel = "progs/v_rock2.mdl";
			self.weaponframe = 0;
			self.zoom = 1;
        }
	}
	else if (self.weapon == IT_LIGHTNING)
	{
		self.currentammo = self.ammo_cells1;
		self.items = self.items | IT_CELLS;
		if (self.aflag == 0)
		{
			stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");
//			if (self.ccamera != TRUE)
//			    self.weaponmodel = "progs/v_light.mdl";
			    self.weaponmodel = "";
			self.weaponframe = 0;
			self.zoom = 1;
        }
	}
	else
	{
		self.currentammo = 0;
		self.weaponmodel = "";
		self.weaponframe = 0;
		self.zoom = 0;
		stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 1\n");
	}

	UpdateAmmoCounts(self);
};

float() W_BestWeapon =
{
	local	float	it;
	
	it = self.items;

	if (self.ammo_cells1 >= 1 && (it & IT_LIGHTNING) )
		return IT_LIGHTNING;
	if (self.ammo_nails1 >= 1 && (it & IT_SUPER_NAILGUN) )
		return IT_SUPER_NAILGUN;
	if (self.ammo_50cal >= 1 && (it & IT_M99) )
		return IT_M99;
	if (self.ammo_nails1 >= 1 && (it & IT_UZI) )
		return IT_UZI;
	if (self.ammo_nails1 >= 1 && (it & IT_NAILGUN) )
		return IT_NAILGUN;
	if (self.ammo_shells1 >= 1 && (it & IT_SUPER_SHOTGUN) )
		return IT_SUPER_SHOTGUN;
	if (self.ammo_nails1 >= 1 && (it & IT_SHOTGUN) )
		return IT_SHOTGUN;
	if (it & IT_AXE)
	    return IT_AXE;
	if (it & IT_TEKBOW)
        return IT_TEKBOW;
};

float() W_CheckNoAmmo =
{
	if (self.currentammo >= 0)
		return TRUE;

	if (self.weapon == IT_AXE)
		return TRUE;
		
	if (self.weapon == IT_TEKBOW)
		return TRUE;

    if (self.weapon == IT_LIGHTNING)
		return TRUE;

	if (self.weapon == IT_M99)
		return TRUE;

	self.weapon = W_BestWeapon ();

	W_SetCurrentAmmo ();

// drop the weapon down
	return FALSE;
};

/*
============
W_Attack

An attack impulse can be triggered now
============
*/

void()	player_knife1;
void()	player_knifeb1;
void()	player_knifec1;
void()	player_knifed1;
void()	player_shot1;
void()	player_light1;
void()	player_rocket1;

void() 	player_arrow1
void()  player_pistol1;
void()  player_lpistol1;
void()  player_rpistol1;
void()	player_rifle1;
void()	player_rrifle1;
void()	player_uzi1;
void()	player_ruzi1;
void()	player_srifle;
void()	player_minigun1;

void()  player_changeup;

//////////////////////////////////
// Reloading
//////////////////////////////////

/*
===============
W_WeaponReloaded
===============
*/

void() W_WeaponReloaded =
{
     self.ammoready = 1;
     self.aflag = 0;               // use to say gun isn't down
     self.think1 = SUB_Null;       // no longer need to re-raise gun
};

/*
=============
W_WeaponReload
=============
*/

void() W_WeaponReload =
{

// Pistol Reload

	if (self.weapon == IT_SHOTGUN)
	{
		if (self.bulletclip == 8)
			return;

		if (self.bulletclip < 8 && self.ammo_nails1 == 0)
			return;

		player_rpistol1 ();
        self.attack_finished = time + 1.15;
	}
	
// Rifle Reload

	if (self.weapon == IT_NAILGUN)
	{
		if (self.rifleclip == 24)
			return;

		if (self.rifleclip < 24 && self.ammo_nails1 == 0)
			return;

		player_rrifle1 ();
        self.attack_finished = time + 1.75;
	}

// Uzi Reload

	if (self.weapon == IT_UZI)
	{
		if (self.uziclip == 32)
			return;

		if (self.uziclip < 32 && self.ammo_nails1 == 0)
			return;

		player_ruzi1 ();
        self.attack_finished = time + 1.5;
	}

	self.aflag = 1;				// use to say gun is down
	self.think1 = W_WeaponReloaded; 	// func to call to raise gun
};

//////////////////////////////////
// Weapon Changing
//////////////////////////////////

/*
===============
W_WeaponChanged
===============
*/

void() W_WeaponChanged =
{
     self.aflag = 0;               // use to say gun isn't down
     self.think1 = SUB_Null;       // no longer need to re-raise gun
};

/*
=============
W_WeaponChange
=============
*/

void() W_WeaponChange =
{
	player_changeup ();
    self.attack_finished = time + 5;

	self.aflag = 1;				    // use to say gun is down
	self.think1 = W_WeaponChanged; 	// func to call to raise gun
};

/*
=============
W_ArrowChange
=============
*/

void() W_ArrowChange =
{
	if (self.ammoready == 0)
        return;

    else
    {
        W_WeaponChange();

	    if (self.secondary == 1)
	    {
		    self.secondary = 0;
		    return;
        }
        else
        {
            if (self.ammo_rockets1 == 0)
            {
                self.secondary = 0;
                return;
            }
            else if (self.secondary == 0)
            {
		        self.secondary = 1;
		        return;
            }
        }
    }
};

/*
=============
W_Secondary Mode
=============
*/
void() W_SecondaryMode =
{
	W_WeaponChange();

    if (self.secondary == 1)
    {
	    self.secondary = 0;
	    return;
    }
    
    else if (self.secondary == 0)
    {
	    self.secondary = 1;
	    return;
    }
};

//////////////////////////////////
// Zooming
//////////////////////////////////

void() zoomInLevel5 = {stuffcmd(self,"fov 75\n scr_ofsy 3\n"); self.attack_finished = time; player_run ();}
void() zoomInLevel4 = {self.think = zoomInLevel5; self.nextthink = time + 0.01; stuffcmd(self,"fov 78\n scr_ofsy 3\n");}
void() zoomInLevel3 = {self.think = zoomInLevel4; self.nextthink = time + 0.01; stuffcmd(self,"fov 82\n scr_ofsy 2\n");}
void() zoomInLevel2 = {self.think = zoomInLevel3; self.nextthink = time + 0.01; stuffcmd(self,"fov 87\n scr_ofsy 1\n");}
void() zoomInLevel1 = {self.think = zoomInLevel2; self.nextthink = time + 0.01; stuffcmd(self,"fov 89\n scr_ofsy 0\n");}

void() zoomOutLevel5 = {stuffcmd(self,"fov 90\n scr_ofsy 0\n"); self.attack_finished = time; player_run ();}
void() zoomOutLevel4 = {self.think = zoomOutLevel5; self.nextthink = time + 0.01; stuffcmd(self,"fov 89\n scr_ofsy 0\n");}
void() zoomOutLevel3 = {self.think = zoomOutLevel4; self.nextthink = time + 0.01; stuffcmd(self,"fov 87\n scr_ofsy 1\n");}
void() zoomOutLevel2 = {self.think = zoomOutLevel3; self.nextthink = time + 0.01; stuffcmd(self,"fov 82\n scr_ofsy 2\n");}
void() zoomOutLevel1 = {self.think = zoomOutLevel2; self.nextthink = time + 0.01; stuffcmd(self,"fov 78\n scr_ofsy 3\n");}

void() zoomInMediumLevel5 = {stuffcmd(self,"fov 50\n scr_ofsy 3\n"); self.attack_finished = time; player_run ();}
void() zoomInMediumLevel4 = {self.think = zoomInMediumLevel5; self.nextthink = time + 0.01; stuffcmd(self,"fov 55\n scr_ofsy 3\n");}
void() zoomInMediumLevel3 = {self.think = zoomInMediumLevel4; self.nextthink = time + 0.01; stuffcmd(self,"fov 65\n scr_ofsy 2\n");}
void() zoomInMediumLevel2 = {self.think = zoomInMediumLevel3; self.nextthink = time + 0.01; stuffcmd(self,"fov 75\n scr_ofsy 1\n");}
void() zoomInMediumLevel1 = {self.think = zoomInMediumLevel2; self.nextthink = time + 0.01; stuffcmd(self,"fov 85\n scr_ofsy 0\n");}

void() zoomOutMediumLevel5 = {stuffcmd(self,"fov 90\n scr_ofsy 0\n"); self.attack_finished = time; player_run ();}
void() zoomOutMediumLevel4 = {self.think = zoomOutMediumLevel5; self.nextthink = time + 0.01; stuffcmd(self,"fov 85\n scr_ofsy 0\n");}
void() zoomOutMediumLevel3 = {self.think = zoomOutMediumLevel4; self.nextthink = time + 0.01; stuffcmd(self,"fov 75\n scr_ofsy 1\n");}
void() zoomOutMediumLevel2 = {self.think = zoomOutMediumLevel3; self.nextthink = time + 0.01; stuffcmd(self,"fov 65\n scr_ofsy 2\n");}
void() zoomOutMediumLevel1 = {self.think = zoomOutMediumLevel2; self.nextthink = time + 0.01; stuffcmd(self,"fov 55\n scr_ofsy 3\n");}

void() W_ZoomInClose = {self.think = zoomInLevel1; self.nextthink = time + 0.01; stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 0\n"); self.attack_finished = time + 1;}
void() W_ZoomOutClose = {self.think = zoomOutLevel1; self.nextthink = time + 0.01; stuffcmd(self,"fov 75\n scr_ofsy 3\n cl_autoaim 1\n");self.attack_finished = time + 1;}

void() W_ZoomInMedium = {self.think = zoomInMediumLevel1; self.nextthink = time + 0.01; stuffcmd(self,"fov 90\n scr_ofsy 0\n cl_autoaim 0\n");self.attack_finished = time + 1;}
void() W_ZoomOutMedium = {self.think = zoomOutMediumLevel1; self.nextthink = time + 0.01; stuffcmd(self,"fov 50\n scr_ofsy 3\n cl_autoaim 1\n");self.attack_finished = time + 1;}

void() zoomInFar = {self.weaponmodel = "progs/scope.mdl"; self.attack_finished = time; player_run ();}
void() zoomOutFar = {self.weaponmodel = "progs/v_sniper.mdl"; self.attack_finished = time; player_run ();}

void() W_ZoomInFar = {self.think = zoomInFar; self.nextthink = time + 0.01;  stuffcmd(self,"fov 25\n"); self.attack_finished = time + 1;}
void() W_ZoomOutFar = {self.think = zoomOutFar; self.nextthink = time + 0.01;  stuffcmd(self,"fov 90\n"); self.attack_finished = time + 1;}

void() W_ZoomIn =
{
	self.zoomtoggle = 1;

	if (self.zoom == 1)
		W_ZoomInClose();
	else if (self.zoom == 2)
		W_ZoomInMedium();
	else if (self.zoom == 3)
		W_ZoomInFar();
	else if (self.zoom == 0)
		return;
}

void() W_ZoomOut =
{
	self.zoomtoggle = 0;

	if (self.zoom == 1)
		W_ZoomOutClose();
	else if (self.zoom == 2)
		W_ZoomOutMedium();
	else if (self.zoom == 3)
		W_ZoomOutFar();
	else if (self.zoom == 0)
		return;
}

//////////////////////////////////
// Attacking
//////////////////////////////////

void() W_Attack =
{
	local	float	r;
	local   float   fspeed, bspeed, sspeed, mspeed;

	// Cheat prevention / gameplay checking
	fspeed = cvar("cl_forwardspeed");
	bspeed = cvar("cl_backspeed");
	sspeed = cvar("cl_sidespeed");
	mspeed = cvar("sv_maxspeed");

	if (bspeed > 200 || sspeed > 200 || fspeed > 200 || mspeed > 200)
		error("\n\n\n\n\n == Players speed has been tampered with! == \n");

	spawn_protect_off ();

	if (!W_CheckNoAmmo ())
		return;

	makevectors	(self.v_angle);			// calculate forward angle for velocity

	if (self.weapon == IT_AXE)
	{
		r = random();
		if (r < 0.25)
		{
			player_knife1 ();
			sound (self, CHAN_WEAPON, "weapons/ax1.wav", 1, ATTN_NORM);
        }
		else if (r<0.5)
		{
			player_knifeb1 ();
			sound (self, CHAN_WEAPON, "weapons/ax1.wav", 1, ATTN_NORM);
        }
		else if (r<0.75)
		{
			player_knifec1 ();
			sound (self, CHAN_WEAPON, "weapons/ax1.wav", 1, ATTN_NORM);
        }
		else
		{
			player_knifed1 ();
		    sound (self, CHAN_WEAPON, "weapons/ax1.wav", 1, ATTN_NORM);
        }
		self.attack_finished = time + 0.5;
	}

	else if (self.weapon == IT_TEKBOW)
	{
        self.aflag = 0;                 // we'll say gun isn't down yet
        self.think1=SUB_Null;         // so we don't need to raise it

		player_arrow1 ();
		self.attack_finished = time + 1000;
	}

	else if (self.weapon == IT_SHOTGUN)
	{
        self.aflag = 0;                 // we'll say gun isn't down yet
        self.think1=SUB_Null;         // so we don't need to raise it

	if(!self.semi)
	{	
		if (self.bulletclip == 0)
		{
/*            if (self.reload == 0)
            {
                if (self.t_width < time)
                {
                    sound (self, CHAN_AUTO, "weapons/dryf.wav", 1, ATTN_NORM);
                    self.t_width = time + 0.6;
                }
            }
            else*/ if(self.ammo_nails1 >= 1)
    			W_WeaponReload();
        }
		else
		{
			if (self.bulletclip == 1)
			{
				player_lpistol1 ();
				sound (self, CHAN_AUTO, "weapons/p_slide_b.wav", 1, ATTN_NORM);
			}
			else
			{
				player_pistol1 ();
			}
				W_FirePistol ();
				self.show_hostile = time + 1;	// wake monsters up
				self.attack_finished = time + 0.175;
				
				if (self.ishuman)	// frikbots ALWAYS use autofire
					self.semi = 1;
			}
		}
	}	

	else if (self.weapon == IT_SUPER_SHOTGUN)
	{
		player_shot1 ();
		W_FireShotgun ();
		self.show_hostile = time + 1;	// wake monsters up
		self.attack_finished = time + 0.9;
	}
	else if (self.weapon == IT_NAILGUN)
	{
        self.aflag=0;                 // we'll say gun isn't down yet
        self.think1=SUB_Null;         // so we don't need to raise it

        if (self.rifleclip == 0)
       	{
/*          if (self.reload == 0)
            {
                if (self.t_width < time)
                {
		          sound (self, CHAN_AUTO, "weapons/dryf.wav", 1, ATTN_NORM);
		          self.t_width = time + 0.6;
                }
            }
            else*/ if(self.ammo_nails1 >= 1)
		    {
			    W_WeaponReload();
                self.attack_finished = time + 1.75;
 	        }
        }
        else
        {
    		player_rifle1 ();
    		W_FireAssualtRifle ();
    	    self.show_hostile = time + 1;	// wake monsters up
    		self.attack_finished = time + 0.1;
        }
	}

	else if (self.weapon == IT_UZI)
	{
        self.aflag = 0;                 // we'll say gun isn't down yet
        self.think1=SUB_Null;         // so we don't need to raise it

	if(!self.semi)
	{
		if (self.uziclip == 0)
		{
/*            if (self.reload == 0)
            {
                if (self.t_width < time)
                {
                    sound (self, CHAN_AUTO, "weapons/dryf.wav", 1, ATTN_NORM);
                    self.t_width = time + 0.6;
                }
            }
            else*/ if(self.ammo_nails1 >= 1)
    			W_WeaponReload();
        }
		else
		{
			player_uzi1 ();
			W_FireUzi ();
			self.show_hostile = time + 1;	// wake monsters up
			self.attack_finished = time + 0.08;

//			if (self.ishuman) // frikbots ALWAYS use autofire
//				self.semi = 1;
                self.semi = 0;
		}
        }
	}

	else if (self.weapon == IT_M99)
	{
        self.aflag = 0;                 // we'll say gun isn't down yet
        self.think1=SUB_Null;         // so we don't need to raise it

		if(!self.semi)
		{
			player_srifle ();
			W_FireSniper ();
			self.show_hostile = time + 1;	// wake monsters up
			self.attack_finished = time + 2.25;

			if (self.ishuman)	// frikbots ALWAYS use autofire
				self.semi = 1;
		}
	}

	else if (self.weapon == IT_SUPER_NAILGUN)
	{
		player_minigun1 ();
		W_FireMiniGun ();
		self.show_hostile = time + 0.1;	// wake monsters up
		self.attack_finished = time + 0.07;
		sound (self, CHAN_AUTO, "weapons/minigun.wav", 1, ATTN_NORM);
	}
	else if (self.weapon == IT_GRENADE_LAUNCHER)
	{
		player_rocket1();
		
		if (self.secondary == 0)
		{
		    W_FireGrenade();
		    self.attack_finished = time + 0.7;
        }
		else
		{
		    W_PlasmaBall();
		    self.attack_finished = time + 1.5;
        }

		self.show_hostile = time + 1;	// wake monsters up
	}
	else if (self.weapon == IT_ROCKET_LAUNCHER)
	{
		player_rocket1();

		if (self.secondary == 0)
		{
			W_FireRocket();
			self.attack_finished = time + 1;
		}
		else
		{
			W_FireMissile();
			self.attack_finished = time + 800;
		}

		self.show_hostile = time + 1;	// wake monsters up
	}
	else if (self.weapon == IT_LIGHTNING)
	{
        W_ThrowMine();
		self.attack_finished = time + 1;
	}
};

/*
============
W_ChangeWeapon

============
*/

void() W_ChangeWeapon =
{
	local	float	it, am, fl;
	
	UpdateAmmoCounts(self);

	it = self.items;
	am = 0;
	
	if (self.impulse == 1)
	{
		fl = IT_AXE;
	}
	else if (self.impulse == 107)
	{
		fl = IT_TEKBOW;
	}
	else if (self.impulse == 2)
	{
		fl = IT_SHOTGUN;
		if (self.ammo_nails1 < 1)
			am = 1;
	}
	else if (self.impulse == 3)
	{
		fl = IT_SUPER_SHOTGUN;
		if (self.ammo_shells1 < 1)
			am = 1;
	}		
	else if (self.impulse == 4)
	{
		fl = IT_NAILGUN;
		if (self.ammo_nails1 < 1)
			am = 1;
	}
	else if (self.impulse == 108)
	{
		fl = IT_UZI;
		if (self.ammo_nails1 < 1)
			am = 1;
	}
	else if (self.impulse == 109)
	{
		fl = IT_M99;
		if (self.ammo_50cal < 1)
			am = 1;
	}
	else if (self.impulse == 5)
	{
		fl = IT_SUPER_NAILGUN;
		if (self.ammo_nails1 < 1)
			am = 1;
	}
	else if (self.impulse == 6)
	{
		fl = IT_GRENADE_LAUNCHER;
		if (self.ammo_rockets1 < 1)
			am = 1;
	}
	else if (self.impulse == 7)
	{
		fl = IT_ROCKET_LAUNCHER;
		if (self.ammo_rockets1 < 1)
			am = 1;
	}
	else if (self.impulse == 8)
	{
		fl = IT_LIGHTNING;
//		if (self.ammo_cells1 < 1)
//			am = 1;
	}

	self.impulse = 0;
	
	if (!(self.items & fl))
	{	// don't have the weapon or the ammo
		sprint (self, "no weapon.\n");
		return;
	}
	
	if (am)
	{	// don't have the ammo
		sprint (self, "not enough ammo.\n");
		return;
	}

//
// set weapon, set ammo
//
	self.weapon = fl;

	if (self.ishuman)
		W_WeaponChange ();
	else
		W_SetAmmoOnly();
};

/*
============
CheatCommand
============
*/
void() CheatCommand =
{
	if (deathmatch & DM_DM_MASK)
		return;

	self.ammo_rockets1 = 30;
	self.ammo_nails1 = 250;
	self.ammo_shells1 = 25;

	self.items = self.items |
		IT_SHOTGUN |
		IT_SUPER_SHOTGUN |
		IT_NAILGUN |
		IT_SUPER_NAILGUN |
		IT_GRENADE_LAUNCHER |
		IT_ROCKET_LAUNCHER |

		IT_UZI |
		IT_M99 |
		IT_LIGHTNING;

	self.items = self.items | IT_KEY1 | IT_KEY2;

    self.ammo_50cal = 20;
	self.ammo_cells1 = 15;

	self.impulse = 0;
	W_SetCurrentWeapon();
};

/*
============
CycleWeaponCommand

Go to the next weapon with ammo
============
*/
void() CycleWeaponCommand =
{
	local	float	it, am;

	UpdateAmmoCounts(self);

	it = self.items;
	self.impulse = 0;

	while (1)
	{
		am = 0;

		if (self.weapon == IT_LIGHTNING)
			self.weapon = IT_AXE;
		else if (self.weapon == IT_AXE)
			self.weapon = IT_TEKBOW;
		else if (self.weapon == IT_TEKBOW)
		{
			self.weapon = IT_SHOTGUN;
			if (self.ammo_nails1 < 1)
				am = 1;
		}
		else if (self.weapon == IT_SHOTGUN)
		{
			self.weapon = IT_SUPER_SHOTGUN;
			if (self.ammo_shells1 < 1)
				am = 1;
		}		
		else if (self.weapon == IT_SUPER_SHOTGUN)
		{
			self.weapon = IT_NAILGUN;
			if (self.ammo_nails1 < 1)
				am = 1;
		}
		else if (self.weapon == IT_NAILGUN)
		{
			self.weapon = IT_UZI;
			if (self.ammo_nails1 < 1)
				am = 1;
		}
		else if (self.weapon == IT_UZI)
		{
			self.weapon = IT_M99;
			if (self.ammo_50cal < 1)
				am = 1;
		}
		else if (self.weapon == IT_M99)
		{
			self.weapon = IT_SUPER_NAILGUN;
			if (self.ammo_nails1 < 1)
				am = 1;
		}
		else if (self.weapon == IT_SUPER_NAILGUN)
		{
			self.weapon = IT_GRENADE_LAUNCHER;
			if (self.ammo_rockets1 < 1)
				am = 1;
		}
		else if (self.weapon == IT_GRENADE_LAUNCHER)
		{
			self.weapon = IT_ROCKET_LAUNCHER;
			if (self.ammo_rockets1 < 1)
				am = 1;
		}
		else if (self.weapon == IT_ROCKET_LAUNCHER)
		{
			self.weapon = IT_LIGHTNING;
//			if (self.ammo_cells1 < 1)
//				am = 1;
		}
	
		if ( (it & self.weapon) && am == 0)
		{
			if (self.ishuman)
	        	W_WeaponChange ();
			else
				W_SetAmmoOnly();
			return;
		}
	}
};

/*
============
CycleWeaponReverseCommand

Go to the prev weapon with ammo
============
*/
void() CycleWeaponReverseCommand =
{
	local	float	it, am;

	UpdateAmmoCounts(self);

	it = self.items;
	self.impulse = 0;
	
	while (1)
	{
		am = 0;

		if (self.weapon == IT_LIGHTNING)
		{
			self.weapon = IT_ROCKET_LAUNCHER;
			if (self.ammo_rockets1 < 1)
				am = 1;
		}
		else if (self.weapon == IT_ROCKET_LAUNCHER)
		{
			self.weapon = IT_GRENADE_LAUNCHER;
			if (self.ammo_rockets1 < 1)
				am = 1;
		}
		else if (self.weapon == IT_GRENADE_LAUNCHER)
		{
			self.weapon = IT_SUPER_NAILGUN;
			if (self.ammo_nails1 < 1)
				am = 1;
		}
		else if (self.weapon == IT_SUPER_NAILGUN)
		{
			self.weapon = IT_M99;
			if (self.ammo_50cal < 1)
				am = 1;
		}
		else if (self.weapon == IT_M99)
		{
			self.weapon = IT_UZI;
			if (self.ammo_nails1 < 1)
				am = 1;
		}
		else if (self.weapon == IT_UZI)
		{
			self.weapon = IT_NAILGUN;
			if (self.ammo_nails1 < 1)
				am = 1;
		}
		else if (self.weapon == IT_NAILGUN)
		{
			self.weapon = IT_SUPER_SHOTGUN;
			if (self.ammo_shells1 < 1)
				am = 1;
		}		
		else if (self.weapon == IT_SUPER_SHOTGUN)
		{
			self.weapon = IT_SHOTGUN;
			if (self.ammo_nails1 < 1)
				am = 1;
		}
		else if (self.weapon == IT_SHOTGUN)
		{
			self.weapon = IT_TEKBOW;
		}
		else if (self.weapon == IT_TEKBOW)
		{
			self.weapon = IT_AXE;
		}
		else if (self.weapon == IT_AXE)
		{
			self.weapon = IT_LIGHTNING;
//			if (self.ammo_cells1 < 1)
//				am = 1;
		}
	
		if ( (it & self.weapon) && am == 0)
		{
			if (self.ishuman)
	        	W_WeaponChange ();
			else
				W_SetAmmoOnly();
			return;
		}
	}

};

/*
============
ServerflagsCommand

Just for development
============
*/
void() ServerflagsCommand =
{
	if (deathmatch & DM_DM_MASK)
		return;
	serverflags = serverflags * 2 + 1;
};

void() QuadCheat =
{
	if (deathmatch & DM_DM_MASK)
		return;
	self.super_time = 1;
	self.super_damage_finished = time + 30;
	self.items = self.items | IT_QUAD;
	dprint ("quad cheat\n");
};

void() PlayerSkinIncrement =
{
    local string    sk;
    
    self.skin = self.skin + 1;
    if (self.skin > 13)
        self.skin = 0;
    sk = ftos(self.skin);
    sprint (self, "Using Player Skin -> #");
    sprint (self, sk);
    sprint (self, "\n");
};

void() PlayerSkinDecrement =
{
    local string    sk;
    
    self.skin = self.skin - 1;
    if (self.skin < 0)
        self.skin = 13;
    sk = ftos(self.skin);
    sprint (self, "Using Player Skin -> #");
    sprint (self, sk);
    sprint (self, "\n");
};

/*
============
ImpulseCommands

============
*/
void() ImpulseCommands =
{
	if (self.impulse >= 1 && self.impulse <= 8)
        if (!self.button0)
		    W_ChangeWeapon ();

	if (self.impulse == 9)
        if (!self.button0)
		    CheatCommand ();

	if (self.impulse == 10)
	    if (!self.button0)
		    CycleWeaponCommand ();

	if (self.impulse == 11)
		ServerflagsCommand ();

	if (self.impulse == 12)
        if (!self.button0)
		    CycleWeaponReverseCommand ();

	if (self.impulse == 13)
		if ((self.weapon == IT_TEKBOW) && (self.ammo_rockets1 >= 1))
             W_ArrowChange ();
        else if ((self.weapon == IT_ROCKET_LAUNCHER) || (self.weapon == IT_GRENADE_LAUNCHER))
             W_SecondaryMode ();

        else if (self.weapon == IT_LIGHTNING)
             Detonate ();
      	else if (!self.button0)
             W_WeaponReload ();

	if (self.impulse == 14)
    	if (self.zoomtoggle == 0)
			W_ZoomIn ();
		else
			W_ZoomOut ();
/*
   	if (self.impulse == 16)
		CCam ();
    if (self.impulse == 17)
        CCamUp (2);
    if (self.impulse == 18)
        CCamRight (2);
    if (self.impulse == 19)
        CCamForward (2);        
    if (self.impulse == 20)
        CCamUp (-2);
    if (self.impulse == 21)
        CCamRight (-2);
    if (self.impulse == 22)
        CCamForward (-2);
*/
//    if (self.impulse == 23)
//        PlayerSkinDecrement ();
//    if (self.impulse == 24)
//        PlayerSkinIncrement ();

// Impulse for checkpoint save system.

	if (self.impulse == 253)
	{
		if (deathmatch & DM_DM_MASK || coop)
			return;

		stuffcmd(self,"save s11\n");
		sprint (self, "\n");
		sprint (self, "\n");
		sprint (self, "\n");
		sprint (self, "\n");
		sprint (self, "Saving checkpoint\n");
		centerprint (self, "= Checkpoint Reached =");
	}

// Impulse designed for title screen.

    if (self.impulse == 254)
    {
		self.weaponmodel = "";
		stuffcmd(self,"viewsize 130\n fog 100 500 25 35 50\n");
    }

	if (self.impulse == 255)
		QuadCheat ();
		
	self.impulse = 0;
};

/*
============
W_WeaponFrame

Called every frame so impulse events can be handled as well as possible
============
*/
void() W_WeaponFrame =
{
	if (time < self.attack_finished)
		return;

//	SightCreate();

    if (!self.button0)
    {
        self.semi = 0;

        if (self.weapon == (IT_SHOTGUN || IT_NAILGUN || IT_UZI))
            self.reload = 1;
    }

    if (self.aflag == 1)         // make sure to fix downed gun
    {
        self.aflag = 0;         // no longer down
        self.think1();          // function called to raise gun
        self.think1=SUB_Null;   // reset pointer
    }

	if (self.impulse)
		ImpulseCommands ();
	
// check for attack
	if (self.button0)
	{
		SuperDamageSound ();
		W_Attack ();
	}
};

/*
========
SuperDamageSound

Plays sound if needed
========
*/
void() SuperDamageSound =
{
	if (self.super_damage_finished > time)
	{
		if (self.super_sound < time)
		{
			self.super_sound = time + 1;
			sound (self, CHAN_BODY, "items/damage3.wav", 1, ATTN_NORM);
		}
	}
	return;
};


void(entity theEntity) UpdateAmmoCounts =
{
	if ( self.weapon >= IT_M99 )
	{
		theEntity.ammo_shells = theEntity.ammo_shells1;
		theEntity.ammo_nails = theEntity.ammo_50cal;
		theEntity.ammo_rockets = theEntity.ammo_rockets1;
		theEntity.ammo_cells = theEntity.ammo_cells1;
	}
	else
	{
		theEntity.ammo_shells = theEntity.ammo_shells1;
		theEntity.ammo_nails = theEntity.ammo_nails1;
		theEntity.ammo_rockets = theEntity.ammo_rockets1;
		theEntity.ammo_cells = theEntity.ammo_cells1;
	}
};
